﻿'From Squeak4.1 of 17 April 2010 [последнее обновление: #0] on 14 May 2011 at 7:04:50 pm'!

!QStyles class methodsFor: 'initializing' stamp: 'sn 5/7/2011 18:19'!
defaultStylesWithLM
	"These are the core system styles always preloaded at instance creation time,
	 if Liberation Mono is in the image."
	| style |
	style := #'LiberationMono'.

	^ Dictionary newFromPairs: {
		#AnnotationStyle . 	"QLabel2D" 
				(QStyles style: style size: 12) .

		#SmallControlStyle . 	"Participant controls."  
				(QStyles style:  style size: 10) .
		#ControlStyle . 		"Participant controls."  
				(QStyles style:  style size: 11) .
		#LargeControlStyle	. "Headline labels." 
				(QStyles style: style size: 14) .

		#SmallListStyle. 		"List items."
				(QStyles style:  style size: 10) .
		#ListStyle. 		"List items."
				(QStyles style: style size: 11).

		#SmallTextStyle .	"Bulk text"
				(QStyles style: style size: 10).
		#TextEditStyle .		"Various multiline text areas."
				(QStyles style: style size: 11).

		#AvatarLabelStyle .	"Variable-size labels above avatars."
				(TextStyle named: style) .

		"The font size controls the -quality- of a sign or note, not its size.
		  Smaller allows longer notes to stay within the 'true-size' range."
		#LabelStyle	.		"QLabel" 		
				((QStyles style: style size: 14) centered; yourself) .
		#SignStyle	.		"QDisplaySign" 		
				((QStyles style: style size: 24) centered; yourself) .
		#NoteStyle	.		"QStickyNote" 		
				((QStyles style: style size: 12) yourself) .
		#CardStyle	.		"Topic cards, etc."
				((QStyles style: style size: 14) yourself) .

		#TMenuStyle	.	 "In-space menu rendering" 
				(QStyles style: style size: 14) .
	}.! !


!CDefaultWidgetLibrary methodsFor: 'basic' stamp: 'sn 5/13/2011 13:16'!
balloonFont
	(TextConstants includesKey: #'LiberationMono') ifTrue: [
		^ (TextConstants at: #'LiberationMono')  fontOfPointSize: 10
	].
	^ BalloonMorph balloonFont! !

!CDefaultWidgetLibrary methodsFor: 'menus' stamp: 'sn 5/14/2011 15:52'!
menuFont
	^ (TextConstants includesKey: #'LiberationMono') ifTrue: [
		 (TextConstants at: #'LiberationMono') fontOfPointSize: 12.
	] ifFalse: [
		StrikeFont familyName: #BitstreamVeraSans pointSize: 10
	]! !


!CDialog class methodsFor: 'confirming' stamp: 'sn 5/13/2011 22:14'!
confirm: aString centerAt: aPoint
	^self confirm: aString label:'Attention:' translateMe centerAt: aPoint! !


!QAvatarChooser methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:49'!
setupCostume
	| label |

	super setupCostume.
	self balloonHelp: 'Choose your avatar''s appearance' translateMe.
	self title: 'My Avatar' translateMe.
	self defaultExtent:  360@300.
	self minExtent: 360@300.
	self extent: self defaultExtent.
	self graphicForm: (QForms find: 'PaneFill.gif'); graphicFit: #tile.

	self setupPanel: (CPlayer new).
	panel layout: CProportionalLayout new.
	panel fillColor: Color transparent.
	self layout: nil.		"Tweak doesn't like nested proportional managers.
						 So I'll do panel manually, and use it as manager around the rest."

	"The backpanel visually contains the detail pane (usually a simple group of widgets),
	 and the family-choice menu, but not the ok/apply buttons."
	backPanel layoutFrame: 
			(CLayoutFrame fractions:(0@0 corner: 0.72@1) offsets: (0@0 corner: 0@-30));
		hResizing: #spaceFill; vResizing: #spaceFill;
		roundCorners:true;
		roundCornerSpec: #(2);
		fillColor: (QColors innerPaneColor);
		fillAlpha: (0.7).
	self addContent: backPanel.

	liveMirror layoutFrame: 
			(CLayoutFrame fractions:(0.72@0 corner: 1@1) offsets: (0@0 corner: 0@-30));
		borderWidth: 0;
		roundCornerSpec: #(3);
		visible: true.
	self addContent: liveMirror.

	label := CLabel on: 'Family: ' translateMe.
	label textEmphasis: 1; textAnchorPoint: #topRight;
		fullBounds;
		topRight: (self midLine-5@8);
		hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self addContent: label.
	classChooser 
		topLeft: (self midLine+1@7);
		hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self addContent: classChooser.

	classChooser addAll: (self class classChoices keys).

	noDetailsLabel 
		font: (QStyles controlFont);
		hResizing: #shrinkWrap; vResizing:#shrinkWrap;
		topLeft: 10@50.
	backPanel add: noDetailsLabel.

	applyButton label: ' Save ' translateMe;
		font: (QStyles controlFont);
		balloonHelp: 'Save this avatar in your preferences.' translateMe;
		roundCorners:true;
		extent: 72@24;
		layoutFrame: ((CLayoutFrame new) 
			bottomFraction: 1; bottomOffset: -1;
			rightFraction: 0.45; rightOffset: 0;
			yourself).
	self addContent: applyButton.
	
	resetButton label: ' Revert ' translateMe;
		font: (QStyles controlFont);
		balloonHelp: 'Go back to the last avatar you have saved.' translateMe;
		roundCorners:true;
		extent: 72@24;
		layoutFrame: ((CLayoutFrame new) 
			bottomFraction: 1; bottomOffset: -1;
			leftFraction: 0.55; leftOffset: 0;
			yourself).
	self addContent: resetButton.! !


!QChatPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:45'!
setupCostume

	super setupCostume.
	
	self titleBox
		balloonHelp: 'Public text chat. Type <Return> anywhere, or click in the input box at the bottom, to start a message.'translateMe.
	
	self title: 'Text Chat' translateMe.
	self minExtent: 140@100.
	self defaultExtent: 320@240.
	self extent: self defaultExtent.

	self setupPanel: chatPlayer.
! !


!QChatPlayer methodsFor: 'events' stamp: 'sn 5/13/2011 15:28'!
onContextMenu
	| menu |
	<on: yellowButtonDown>

	messageList selectUnderPointer.

	"Start with title."
	menu := CMenu new.
	(menu add: 'Text Chat' translateMe target: self action: #noSuchAction) 
		disabled: true; 
		separator: true.

	(menu add: 'Copy Message' translateMe target: self action: #copyMessageText)
	 	enabled: (messageList selection notNil);
	 	separator: true.
	"Operations..."
	(menu add: 'Show More Messages' translateMe
		   target: self 
		   action: #showMoreMessages)
		enabled: (self hasMoreMessages);
		separator: true.

	menu add: 'Compose Mail...' translateMe target: owner action: #mailUsers 
		disabled: owner hasForumPagesSupport not.
	menu add: 'Save Transcript...' translateMe target: self action: #saveTranscript.

	owner isAdministrator ifTrue: [
		menu addSeparator.
		menu add: 'Clear Chat Transcript' translateMe target: self action: #clearTranscript.
	].

	QStyles installMenuFontInMenu: menu.
	menu openAt: hand position.! !


!QControlBar methodsFor: 'initialize' stamp: 'sn 5/8/2011 18:54'!
setupCostume

	"@ Note - balloon help is coded, but suppressed in favor
	 of status-line mouseover messages which are less disruptive.
	 Some controls (e.g. microphone) are dynamically placed
	 and so their balloon help is commented... the others 
	 are suppressed by a children-do: at the bottom of this method."

	| invisible lblColor |
	super setupCostume.
	self sticky: true. "prevent me from being picked up willy nilly"
	invisible := Color r: 0.0 g: 0.0 b: 0.0 alpha: 0.0.

	self color: (Color white).
	self fillAlpha: 1.0.
	self fillColors: (CWidgetLibrary default menuColors).
	self fillStyle: #verticalGradient.

	"The border is set up to give a top line to match the bottom of the menu bar;
	 the participant ui submerges the other three border edges to save space."
	self height: 34.
	self borderWidth: 1.
	self borderColor: (QColors mainBorderColor).
	self borderStyle: #simple.

	lblColor := (Color r: 0.01 g: 0.15 b: 0.2). 

	messageArea color: invisible;
		font: QStyles controlFont;
		extent: 300@20;
		hResizing: #rigid;
		textColor: lblColor;
		balloonHelp: 'Status and information messages.';
		top: 9;
		label: ''.
	self add: messageArea.

	editIndicator 	label: ' [Editing]' translateMe;
		font: QStyles smallControlFont;
		textColor: lblColor;
		textOffset: (0@-2); top: (1); 
		vResizing: #rigid;
		hResizing: #shrinkWrap;
		fullBounds;
		 fillAlpha: 1.0;
		 fillColors: (CWidgetLibrary default menuColors);
		 fillStyle: #verticalGradient;		
		 visible: false.
	self add: editIndicator.

	svcCountLabel color: invisible;
		textFont: (QStyles smallControlFont);
		hResizing: #shrinkWrap;
		textColor: (Color r:0.1 g:0.1 b:0.7).
	self add: svcCountLabel.
	svcCount color: invisible;
		textFont: (QStyles smallControlFont);
		hResizing:#shrinkWrap;
		textColor: (Color r:0.0 g:0.4 b:0.5);
		" balloonHelp: 'The number of forums you are connected to.';	 
			Deliberately absent,
			because the svcCount has a status-line mouseover and the b-h distracts from it."
		value: '';
		textAnchorPoint: #rightCenter.
	self  add: svcCount.

	appCountLabel color: invisible;
		textFont: (QStyles smallControlFont);
		hResizing: #shrinkWrap;
		textColor: (Color r:0.1 g:0.1 b:0.7).
	self add: appCountLabel.

	appCount color: invisible;
		textFont: (QStyles smallControlFont);
		hResizing:#shrinkWrap;
		textColor: (Color r:0.1 g:0.1 b:0.7);
		value: '';
		textAnchorPoint: #rightCenter.
	self add: appCount.
	netHealth color: invisible;
		textFont: (QStyles smallControlFont);
		hResizing:#shrinkWrap;
		textColor: (Color r:0.1 g:0.1 b:0.7);
		value: 'Network:'.
	self add: netHealth.
	renderHealth color: invisible;
		textFont: (QStyles smallControlFont);
		hResizing:#shrinkWrap;
		textColor: (Color r:0.1 g:0.1 b:0.7);
		value: 'Graphics:'.
	self add: renderHealth.

	askToSpeak color: invisible;
		extent: 32@32.
	self setupAskToSpeakButtonForAudience.
	self add: askToSpeak.

	thumbtack color: invisible;
		extent: 24@24;
		balloonHelp: 'Set the pointer mode to create a sticky note.' translateMe;
		normalImage: (QForms find:'StickyNoteNormal.png');
		pressedImage: (QForms find: 'StickyNoteDown.png');
		selectedImage: (QForms find: 'StickyNoteDown.png');
		selectedPressedImage: (QForms find: 'StickyNoteDown.png');
		disabledImage: (QForms find: 'StickyNoteDisabled.png');
		overImage: (QForms find: 'StickyNoteOver.png').
	self add: thumbtack.

	editBox color: invisible;
		extent: 24@24;
		balloonHelp: 'Set the pointer mode for editing objects position and scale.';
		normalImage: (QForms find: 'edit.png');
		pressedImage: (QForms find:'editDown.png');
		selectedImage: (QForms find: 'editDown.png');
		selectedPressedImage: (QForms find: 'editDown.png');
		overImage: (QForms find: 'editOver.png').
	self add: editBox.

	microphone 
		selected: false.
	self add: microphone.

	speaker 
		selected: QAudioDeviceManager playerDevices isEmpty not.
	self add: speaker.

	"only for developers, for now"
	camera color: invisible;
		extent: 32@32;
	"@	balloonHelp: 'Turn video camera on or off.  Press and hold to select video-chat quality.'; "
		normalImage: (QForms find: 'cameraOff.png');
		pressedImage: (QForms find: 'cameraDown.png');
		overImage: (QForms find: 'cameraOffOver.png');
		selectedImage: (QForms find: 'cameraOn.png');
		selectedOverImage: (QForms find: 'cameraOnOver.png');
		selectedPressedImage: (QForms find: 'cameraDown.png');
		selected: false.
		self add: camera.

	awayButton color: invisible;
		extent: 30@30;
		normalImage: (QForms find: 'UserPresent.png');
		overImage: (QForms find: 'UserPresentOver.png');
		selectedImage: (QForms find: 'UserAbsent.png');
		selectedOverImage: (QForms find: 'UserAbsentOver.png');
		selected: false.
	self add: awayButton.

	sitStand color: invisible;
		extent: 32@32;
		normalImage: (QForms find: 'SitDownIcon.png');
		overImage: (QForms find: 'SitDownOver.png');
		selectedImage: (QForms find: 'StandUpIcon.png');
		selectedOverImage: (QForms find: 'StandUpOver.png');
		selected: false.
	self add: sitStand.


	readoutButton color: invisible;
		extent: 115@30;
		balloonHelp: '(Bring up the position readout.)';
		normalImage: (QForms openqwaqLogoClearCBForm);
		selectedImage: (QForms openqwaqLogoClearCBForm);
		overImage: (QForms openqwaqLogoClearCBForm);
		selectedOverImage: (QForms openqwaqLogoClearCBForm);
		graphicFit: #rigid;
		graphicAnchorPoint: #center.
	self add: readoutButton. 

	inventory color: invisible;
		extent: 32@32;
		balloonHelp: 'Show or hide your inventory.';
		normalImage: (QForms find:'inventoryClosed.png');
		selectedImage: (QForms find: 'inventoryOpen.png');
		overImage: (QForms find:'inventoryClosedOver.png');
		selectedOverImage: (QForms find:'inventoryOpenOver.png');
		disabledImage: (QForms find: 'inventoryDisabled.png');
		fillAlpha:0.9.
	self add: inventory. 

	ioIcon color: invisible;
		extent: 16@24;
		balloonHelp: 'Indicates resource transfer activity.';
		graphic: (QForms find: 'io.png');
		visible: false.
	self add: ioIcon.

	"Suppress all those balloon helps (keeping them in case someone changes my mind.
	 See 'tips' category... we put terse tips into the status line itself for each control.
	 This works well for the control bar since the user's attention is already here."
	self collection do: [ :c | c balloonHelp: nil ].
		
	6 timesRepeat: [
		| divider |
		divider := CPlayer new.
		divider fillAlpha: 1.
		divider graphicForm: (QForms find:  'ControlBarDivider.png').
		divider extent: 2@32.
		divider borderWidth: 0.
		self add: divider.
		dividers add: divider.
	].

	"Layout comes later, and is the responsibility of the owner."! !

!QControlBar methodsFor: 'tips' stamp: 'sn 5/13/2011 22:48'!
onAwayButtonEnter
	<on: mouseEnter in: awayButton>

	awayButton selected ifTrue: [
		owner statusInfo: 'Away.  Voice chat suspended.  Click to return.'  translateMe.
	] ifFalse: [
		userIsIdle ifTrue: [
			owner statusInfo: 'You are present but Idle. Click for Away.'  translateMe.
		] ifFalse: [
			owner statusInfo: 'You are present and active.  Click for Away.' translateMe.
		].
	].! !

!QControlBar methodsFor: 'tips' stamp: 'sn 5/13/2011 22:43'!
onInventoryEnter
	"Status-line info for the Inventory button."

	<on: mouseEnter in: inventory>
	owner avatar ifNil:[ ^self].
	owner avatar replica ifNil: [ ^ self ].
	inventory selected ifFalse: [
		owner statusInfo: 'Click to show the Object Catalog.' translateMe.
	] ifTrue: [
		owner statusInfo: 'Click to hide the Object Catalog.' translateMe
	].	! !

!QControlBar methodsFor: 'tips' stamp: 'sn 5/13/2011 22:41'!
onSitStandEnter
	<on: mouseEnter in: sitStand>

	owner avatar ifNil:[ ^self].
	owner avatar replica ifNil: [ ^ self ].
	owner allowedToMove ifFalse: [
		^ owner statusInfo: 'The leader is controlling movement.' translateMe
	].

	sitStand selected ifTrue: [
		owner statusInfo: ('Click to stand up.' translateMe).
	] ifFalse: [
		sitStand overImage = (QForms find: 'SitDownOver.png') ifTrue: [ 
			owner statusInfo: ('Click to take a seat.' translateMe)
		] ifFalse: [ 
			owner statusInfo: ('No seats nearby.' translateMe)
		].
	].! !

!QControlBar methodsFor: 'tips' stamp: 'sn 5/13/2011 22:38'!
onThumbtackEnter
	<on: mouseEnter in: thumbtack>
	owner statusInfo: 'Tool for adding a sticky note.' translateMe.! !


!QCrowdPane methodsFor: 'initialization' stamp: 'sn 5/8/2011 20:59'!
setupCostume
	| x1 y1 content |

	super setupCostume.

	self
		title: 'Adjust Local Crowd (experimental)' translateMe;
		defaultExtent: 360@380;
		minExtent: 360@380;
		maxExtent: 360@380;
		extent: self defaultExtent.

	content := CPlayer new.
	content
		color: (QColors paneColor alpha:0.9);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		roundCornerSpec: #(2 3).
	self setupPanel: content.

	x1 := 20.
	y1 := 350.

	currentCrowdSizeLabel
		topLeft: (x1+3@(y1-145));
		hResizing: #shrinkWrap.
	content add: currentCrowdSizeLabel.

	currentCrowdSize
		topLeft: (currentCrowdSizeLabel topRight + (100@0));
		hResizing: #shrinkWrap.
	content add: currentCrowdSize.

	newCrowdSizeLabel
		topLeft: (x1+3@(y1-120));
		hResizing: #shrinkWrap.
	content add: newCrowdSizeLabel.

	newCrowdSize
		topLeft: (newCrowdSizeLabel topRight + (100@0));
		width: 50;  
		height: 19;
		fillColor: Color white;
		fillAlpha: 0.75;
		hResizing: #spaceFill;
		vResizing: #rigid;
		allowEditing: true;
		contents: ''.
	content add: newCrowdSize.

	costumeNameLabel
		topLeft: (x1+3@(y1-95));
		hResizing: #shrinkWrap.
	content add: costumeNameLabel.

	costumeName 
		topLeft: (costumeNameLabel topRight + (100@-1));
		hResizing: #shrinkWrap.
	content add: costumeName.

	cloudInitializationStatusLabel
		topLeft: (x1+3@(y1-70));
		hResizing: #shrinkWrap.
	content add: cloudInitializationStatusLabel.

	adjustButton label: 'Adjust Crowd' translateMe;
		 extent: (125@25);
		 bottomLeft: (x1+2@(y1-10));
		 roundCorners: true.
	content add: adjustButton.

	killButton label: 'Stop Cloud' translateMe;
		 extent: (125@25);
		 bottomLeft: (200@(y1-10));
		 roundCorners: true.
	content add: killButton.

	explanation
		font: (QStyles controlFont);
		topLeft: x1@10;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		fullBounds.
	content add: explanation! !


!QCustomsPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 21:04'!
setupCostume
	super setupCostume.

	self title: 'External Uploads' translateMe.
	self defaultExtent: 320@240.
	self minExtent: 240@(60 + (self footerHeight)).
	self extent: self defaultExtent.

	itemList
		color: (Color white);
		borderColor: (Color gray alpha: 0.3);
		itemMaker: QCustomsListItem;
		keepCursorInView: true;
		hScrollable: false; 
		vScrollable: nil. 	"On demand."

	self setupBorderedPanel: itemList.
	panel layoutFrame bottomFraction: 1 offset: ((self footerHeight + 1 + inset) negated).	
			"Room for footer - see also layoutFooter"

	footerBox
		borderWidth: 0; borderStyle: #simple;
		fillColor: (QColors paneColor lighter alpha: 0.3).
	self add: footerBox. 
		
	thumbnail
		borderWidth: 0; borderStyle: #simple;
		fillColor: (Color transparent).
	self add: thumbnail.

	listFooter
		label: '';
		hResizing: #rigid; vResizing: #rigid;
		textColor: (Color black);
		textAnchorPoint: #topLeft;
		textFont: (QStyles smallTextFont).
	self add: listFooter.! !


!QDemoPhonePane methodsFor: 'initialize' stamp: 'sn 5/8/2011 21:02'!
setupCostume
	super setupCostume.

	self title: 'Phone' translateMe.
	self defaultExtent: 400@90.
	self minExtent: 400@90.
	self maxExtent: 400@200.
	self extent: self defaultExtent.

	numberLabel label: 'Phone Number:' translateMe.
	numberLabel topLeft: 10@35.
	numberLabel width: 100.
	numberField height: 20.
	numberField width: 
		self defaultExtent x "wish it could be 'self width'... why can't it??" 
		- numberLabel width 
		- 30.
	numberField topLeft: (numberLabel right + 10)@35.
	numberField autoAccept: true.
	actionButton label: 'Call' translateMe.
	actionButton topLeft: 10@60.
	
	self hasPhoneNumber ifTrue: [actionButton enable] ifFalse: [actionButton disable].

	calls topLeft: 10@90.
	calls layout: CTableLayout new.
	calls layout listDirection: #topToBottom.
	calls vResizing: #shrinkWrap.
	"Don't know how else to make it shrink to 0-height when no calls are there."
	calls add: (CPlayer new height: 0; width: 1; color: Color transparent; yourself).

	self add: numberLabel.
	self add: numberField.
	self add: actionButton.
	self add: calls.
! !


!QHelpButton methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:15'!
setupCostume
	super setupCostume.
	self font: QStyles controlFont;
		balloonHelp: 'Get more detailed information in a Help browser.' translateMe;
		roundCorners: true.! !


!QHistoryPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:56'!
setupCostume

	super setupCostume.

	self title: 'History' translateMe.
	self defaultExtent: 280@160;
		extent: 280@160;
		minExtent: 200@100.
	historyList color: (Color white alpha: 0.6).
	historyList borderColor: (Color gray alpha: 0.4).

	historyList allowDeselect.
	historyList hScrollable: false; vScrollable: nil. 	"On demand."
	self setupBorderedPanel: historyList.
	! !


!QInspector methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:19'!
setupCostume
	"Create the default costume"
	super setupCostume.
	self title: 'Scene Inspector' translateMe.

	self defaultExtent: 300@360;
		extent: 300@360;
		minExtent: 260@140.
	self fillColor: (QColors paneDarkerColor alpha: 0.75).

	objectsTree costume: (QInspectorTreeCostume new).
	objectsTree color: (Color white alpha: 0.6).
	objectsTree borderColor: (Color gray alpha: 0.4).
	objectsTree hScrollable: false; vScrollable: true.
	objectsTree hScrollable: false; vScrollable: nil. 	"On demand."
	objectsTree allowDeselect: true.

	self setupBorderedPanel: objectsTree.

	editTemplateToggle label: 'Edit Fixed Scene' translateMe;
					    font: (QStyles smallControlFont);
					    selected: false;
					    value: false;
					    hResizing: #shrinkWrap;
					    vResizing: #shrinkWrap;
					    selected: false;
					    fullBounds.
	self add: editTemplateToggle.

	sortChoice addAll: {'Sort by Name' . 'Oldest First' translateMe}.
	sortChoice value: 'Sort by Name' translateMe.
	sortChoice fullBounds; hResizing: #rigid.
	sortChoice font: (QStyles smallControlFont).
	sortChoice hResizing: #shrinkWrap.
	self add: sortChoice.

	(panel layoutFrame)
		topOffset: (panel layoutFrame topOffset) + (self headerHeight) + 2;
		bottomOffset: (panel layoutFrame bottomOffset 
									- (editTemplateToggle height + 6)).
	self setupHeader.

! !


!QLatencyPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:36'!
setupCostume

	| label tag |
	super setupCostume.
	self fillAlpha: 0.8.

	self title: 'System Timings' translateMe.
	self defaultExtent: 330@180.
	self extent: self defaultExtent.

	"The legend labels take their text from the router constants,
	 and their color from the traffic-watcher color table."

	1 to: QLatencyWatcher numLatencyTags do: [ :i|
		tag := QLatencyWatcher latencyTagName: i.
		label := CLabel on: tag.
		legendLabels at: i put: label.
		label hResizing: #shrinkWrap.
		label textColor: (watcher colorTable at: tag) muchDarker.
		label font: (QStyles smallTextFont).
		label balloonHelp: (QLatencyWatcher balloonHelpFor: tag).
		self startScript: #onLegendClick: withArguments: {label} when: {label. #mouseDown}.
		self startScript: #onLegendEnter: withArguments: {label} when: {label. #mouseEnter}.
		self startScript: #onLegendLeave: withArguments: {label} when: {label. #mouseLeave}.
		self add: label.
	].
	self layoutLegend.

	watcher plotStyle: #lines.
	summaryLabel font: (QStyles smallTextFont).
	summaryLabel hResizing: #rigid.
	peakLabel font: (QStyles smallTextFont).
	peakLabel hResizing: #shrinkWrap.
	peakLabel balloonHelp: 'Click to change the timespan.' translateMe.

	plotLabel font: (QStyles smallTextFont).
	plotLabel hResizing: #shrinkWrap.
	plotLabel balloonHelp: 'Click to change the plot style.' translateMe.
	self add: watcher.
	self add: peakLabel.
	self add: summaryLabel.
	self add: plotLabel.! !


!QLogView methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:43'!
setupCostume

	| logText |
	super setupCostume.

	self title: 'System Transcript'translateMe.
	self defaultExtent: 500@160;
		extent: 500@160.
	
	logText := CTextEditor new.
	logText color: (Color white alpha:0.8).
	logText borderWidth: 1; borderStyle:#simple; borderColor: (Color gray: 0.6).
	logText textFont: (QStyles smallTextFont).
	self setupBorderedPanel: logText.

	initialAlignment := #bottomRight.
	givesAwayFocus := false.
	self revertText.! !


!QMainViewPlayer methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:16'!
setupCostume
	super setupCostume.
	self borderWidth: 0.

	crosshairs 
		label: '';
		graphicForm: ( QForms find: 'DrivingCrosshairs.png');
		graphicFit: #rigid;
		fillAlpha: 0;
		borderWidth: 0;
		hResizing: #rigid; vResizing: #rigid;
		extent: (crosshairs graphicForm extent);
		visible: false.

	self add: crosshairs.! !


!QMaterialCatalog methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:11'!
setupCostume
	| ext content |
	super setupCostume.

	ext := 205@360.
	self minExtent: ext - (0@180).
	self maxExtent: ext + (40@500).
	self defaultExtent: ext.
	self extent: (self defaultExtent).
	self title: 'Theme Materials' translateMe.
	
	content := CPlayer new.
	content color: (QColors paneColor alpha: 0);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		roundCornerSpec: #(2 3).
	self setupPanel: content.
	
	sortDropDown addAll: {'Sort by Name' translateMe}.
	content add: sortDropDown.
	sortDropDown cursor: 1.
	
	header label: 'All Theme Materials' translateMe;
			hResizing: #shrinkWrap.
	content add: header.
	
	matList itemMaker: QMaterialItem.
	content add: matList.
	QListClickListener installNewIn: matList.
		
	addButton label: '+'; font: QStyles largeControlFont;  
				hResizing: #rigid;
				vResizing: #shrinkWrap.
	content add: addButton.
	
	deleteButton label: '-'; font: QStyles largeControlFont;  
				hResizing: #rigid;
				vResizing: #shrinkWrap.
	content add: deleteButton.
	deleteButton disable.! !


!QMicrophoneMenuButton methodsFor: 'tips' stamp: 'sn 5/13/2011 22:52'!
onMicrophoneEnter
	| |
	<on: mouseEnter in: self>
	
 	self owner audioSession 
		ifNil: [ ^ self ]
		ifNotNilDo: [ :sess|
			self owner statusInfo: (
				self selected 
				ifTrue: [ 
					'Microphone is on.' translateMe,
					(sess isPressToTalk ifTrue: [ 'Hold down control key to talk.' translateMe ] ifFalse: [''])]
				ifFalse: [ 
					'Microphone is off. (Click to start. Press for settings.)' translateMe] ) ].! !


!QNavPanel methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:04'!
setupCostume

	| invisible |
	super setupCostume.
	"self sticky := true."  "prevent me from being picked up willy nilly"
	invisible := Color r: 0.0 g: 0.0 b: 0.0 alpha: 0.0.

	self fillColor: QColors paneColor.
	self fillAlpha: 0.6.
	self borderStyle: #simple.
	self roundCorners: true.
	self borderWidth: 1.	"Until we're up and in-use."
	self borderColor: (Color lightGray alpha: 0.1).

	self extent: 320@64.

	compassArrow color: invisible;
		extent: 39@39;
		pivot: 20@20;
		normalImage: (QForms find: 'compassArrow.png');
		pressedImage: (QForms find: 'compassArrow.png');
		overImage: (QForms find:  'compassArrow.png');
		color: (Color white).

	compassArrow layoutFrame: CLayoutFrame new.
	self add: compassArrow.
	compassArrow angle: 1.

	compassRose color: invisible;
		extent: 64@64;
		balloonHelp: ('Indicates the direction you are facing. Click in the rim to turn.' translateMe );
		normalImage: (QForms find: 'compassRose.png');
		pressedImage: (QForms find: 'compassRoseDown.png');
		overImage: (QForms find: 'compassRoseOver.png').
	compassRose layoutFrame: CLayoutFrame new.
	self add: compassRose.

	resetPosition color: invisible;
		balloonHelp: 'Return to the center of the space.' translateMe;
		extent: 24@24;
		normalImage: (QForms find: 'center.png');
		pressedImage: (QForms find: 'centerDown.png');
		overImage: (QForms find: 'centerOver.png').
	resetPosition layoutFrame: CLayoutFrame new.
	self add: resetPosition.

	lookDown color: invisible;
		balloonHelp: 'Look downward.' translateMe;
	  	extent:24@24;
		normalImage: (QForms find: 'lookDown.png');
		pressedImage: (QForms find: 'lookDownDown.png');
		overImage: (QForms find: 'lookDownOver.png').
	lookDown  layoutFrame: CLayoutFrame new.
	self add: lookDown.

	lookUp color: invisible;
	   balloonHelp: 'Look upward.' translateMe;
	   extent:24@24;
	   normalImage:(QForms find:  'lookUp.png');
		pressedImage: (QForms find:'lookUpDown.png');
		overImage: (QForms find: 'lookUpOver.png').
	lookUp  layoutFrame: CLayoutFrame new.
	self add: lookUp.

	moveBack color: invisible;
		balloonHelp: 'Move backward.' translateMe;
		extent: 24@24;
		normalImage:(QForms find: 'moveBack.png');
		pressedImage: (QForms find: 'moveBackDown.png');
		overImage: (QForms find: 'moveBackOver.png').
	moveBack  layoutFrame: CLayoutFrame new.
	self add: moveBack.

	moveForward color: invisible;
		extent: 24@24;
		balloonHelp: 'Move forward.' translateMe;
		normalImage: (QForms find: 'moveForward.png');
		pressedImage: (QForms find: 'moveForwardDown.png');
		overImage: (QForms find: 'moveForwardOver.png').
	moveForward  layoutFrame: CLayoutFrame new.
	self add:moveForward.

	moveLeft color: invisible;
		extent: 24@24;
		balloonHelp: 'Move left.' translateMe;
		normalImage: (QForms find: 'moveLeft.png');
		pressedImage: (QForms find: 'moveLeftDown.png');
		overImage: (QForms find: 'moveLeftOver.png').
	moveLeft layoutFrame: CLayoutFrame new.
	self add: moveLeft.

	moveRight color: invisible;
		extent: 24@24;
		balloonHelp: 'Move right.' translateMe;
		normalImage: (QForms find: 'moveRight.png');
		pressedImage: (QForms find: 'moveRightDown.png');
		overImage: (QForms find: 'moveRightOver.png').
	moveRight  layoutFrame: CLayoutFrame new.
	self add: moveRight.

	resetLook color: invisible;
		extent: 24@24;
		balloonHelp: 'Reset the viewing angle to horizontal.' translateMe;
		normalImage: (QForms find: 'resetLook.png');
		pressedImage: (QForms find: 'resetLookDown.png');
		overImage: (QForms find: 'resetLookOver.png').
	resetLook  layoutFrame: CLayoutFrame new.
	self add: resetLook.

	resetNorth color: invisible;
		extent: 24@24;
		balloonHelp: 'Turn to face north.' translateMe;
		normalImage: (QForms find: 'resetNorth.png');
		pressedImage: (QForms find: 'resetNorthDown.png');
		overImage: (QForms find: 'resetNorthOver.png').
	resetNorth layoutFrame: CLayoutFrame new.
	self add: resetNorth.

	rotateLeft color: invisible;
		balloonHelp: 'Turn to the left.' translateMe;
		extent: 24@24;
		normalImage: (QForms find: 'rotateLeft.png');
		pressedImage: (QForms find: 'rotateLeftDown.png');
		overImage: (QForms find: 'rotateLeftOver.png').
	rotateLeft  layoutFrame: CLayoutFrame new.
	self add: rotateLeft.

	rotateRight color: invisible;
		balloonHelp: 'Turn to the right.' translateMe;
		extent: 24@24;
		normalImage: (QForms find: 'rotateRight.png');
		pressedImage: (QForms find: 'rotateRightDown.png');
		overImage: (QForms find: 'rotateRightOver.png').
	rotateRight  layoutFrame: CLayoutFrame new.
	self add: rotateRight.

	moveUp color: invisible;
		extent: 24@24;
		balloonHelp: 'Move upwards.' translateMe;
		normalImage: (QForms find: 'zoomIn.png');
		pressedImage: (QForms find: 'zoomInDown.png');
		overImage: (QForms find: 'zoomInOver.png').
	moveUp  layoutFrame: CLayoutFrame new.
	self add: moveUp.

	moveDown color: invisible;
		extent: 24@24;
		balloonHelp: 'Move downwards.' translateMe;
		normalImage: (QForms find: 'zoomOut.png');
		pressedImage: (QForms find: 'zoomOutDown.png');
		overImage: (QForms find: 'zoomOutOver.png').
	moveDown  layoutFrame: CLayoutFrame new.
	self add: moveDown.

	self layoutButtons.
! !


!QPersonalShareWindowPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 21:07'!
setupCostume
	super setupCostume.

	self title: 'Sharable Windows' translateMe.
	self defaultExtent: 320@240.
	self minExtent: 240@100.
	self extent: self defaultExtent.

	windowList
		color: (Color white);
		borderColor: (Color gray alpha: 0.3);
		itemMaker: QPersonalShareWindowListItem;
		keepCursorInView: false;
		hScrollable: false; 
		vScrollable: nil. 	"On demand."

	self setupBorderedPanel: windowList.	! !


!QPlacesTool methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:00'!
setupCostume
	"Create the default costume"
	super setupCostume.
	self title: 'Landmarks' translateMe.
	self extent: 300@320.
	self borderColor: (QColors mainBorderColor).
	self fillColor: (QColors paneColor ).
	self userDraw: true.
	self titleWrapper fillAlpha: 0.95.
	placesList 
		color: (QColors paneColor);
		borderColor: (Color transparent);
		hScrollable: false; vScrollable: nil;
		keepCursorInView: false;
		itemMaker: QPlaceItem.
	self setupBorderedPanel: placesList.
	otherPlaceView
		visible: true;
		renderInterval: 32;	"See onTick/desiredMiniViewInterval. Start light."
		borderWidth: 2;			
		borderColor: (QColors paneColor darker);
		borderStyle: #simple;
		balloonHelp: 'The alternate landmark.\Click to return there.' translateMe withCRs;
		mouseCursor: (QStyles warpPlaceCursor).
	self add: otherPlaceView.
	opLabel
		fillColor: (Color r: 0.95 g: 0.93 b: 0.85  alpha: 0.8);
		label: 'Previous Place' translateMe;
		textColor: (Color black);
		textInset: 5@2;
		textFont: (QStyles smallControlFont);
		hResizing: #shrinkWrap; vResizing: #shrinkWrap;
		roundCornerSpec: #(1).

	"The strip buttons recap the basic actions for the other-view pane."
	switchButton
		label: ' Exchange ' translateMe;
		textFont: (QStyles smallControlFont);
		textEmphasis: 0;
		balloonHelp: 'Switch your current landmark\with the alternate.' translateMe withCRs.
	self addStripButton: switchButton.
	switchButton hResizing: #shrinkWrap.
	self addStripSeparator; addStripSeparator.
	setButton
		label: ' Set ' translateMe;
		textFont: (QStyles smallControlFont);
		textEmphasis: 0;
		balloonHelp: 'Set the alternate landmark\to where you are now.' translateMe withCRs.
	self addStripButton: setButton.
	setButton hResizing: #shrinkWrap.

	otherPlaceView borderColor: (stripButtons fillColor).

	"Defeat the inset on the main panel for better space use (at the app-window boundary.)"
	panel layoutFrame
		leftFraction: 0 offset: -1;
		rightFraction: 1 offset: 1.

	" We'd prefer the opLabel to be part of the otherPlaceView, 
	 but having that manage a child causes strange resizing effects
	 when graphicForm updates interleave with label geometry changes.
	 So we just do the same for label events as we do for place-view events."
	self add: opLabel.
	self hideOtherPlaceLabel.! !


!QPositionReadout methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:50'!
setupCostume

	| invisible lblColor |
	super setupCostume.
	invisible := Color r: 0.0 g: 0.0 b: 0.0 alpha: 0.0.

	self fillColor: (QColors paneColor lighter).
	self fillAlpha: 0.8.
	self borderWidth: 1.
	self borderColor: (Color gray:0.2).
	self borderStyle: #simple.
	self roundCorners: true.
	self extent: 100@64.
	self dropShadowEnabled: true.

	lblColor := (Color r: 0.03 g: 0.03 b: 0.03). 
	self layout: CProportionalLayout new.

	xReadout color: invisible;
		font: QStyles controlFont;
		extent: 100@20;
		textColor: lblColor;
		balloonHelp: 'Your east-west position in this space.' translateMe;
		label: '';
		layoutFrame: CLayoutFrame new.
	self add: xReadout.

	yReadout color: invisible;
		font: QStyles controlFont;
		extent: 100@20;
		textColor: lblColor;
		balloonHelp: 'Your height or depth above or below the origin of this space.' translateMe;
		label: '';
		layoutFrame: CLayoutFrame new.
	self add: yReadout.

	zReadout color: invisible;
		font: QStyles controlFont;
		extent: 100@20;
		textColor: lblColor;
		balloonHelp: 'Your north-south position in this space.' translateMe;
		label: '';
		layoutFrame: CLayoutFrame new.
	self add: zReadout.

	xReadout layoutFrame leftFraction: 0.0; topFraction: 0.5; leftOffset: 5; topOffset: -10.
	yReadout layoutFrame leftFraction: 0.0; topFraction: 0.5; leftOffset: 5; topOffset: 8.
	zReadout layoutFrame leftFraction: 0.0; topFraction: 0.5; leftOffset: 5; topOffset: -28.
! !


!QProxyDialog methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:14'!
setupCostume
	| label |
	super setupCostume.

	self extent: 440@250.
	QFloatingPane setupDialog: self.
	self graphicForm: (QForms find: 'PaneFill.gif'); graphicFit: #tile.

	label := CLabel new.
	label value: 'Proxy Configuration' translateMe.
	label font: QStyles largeControlFont.
	label textColor: QFloatingPane titleColor.
	label textEmphasis: 1.
	label topLeft: 10@10.
	label width: self width-20.
	self add: label.

	rbNoProxy label: 'Direct connection (no proxy)' translateMe.
	rbNoProxy font: QStyles smallControlFont.
	rbNoProxy topLeft: 15@42.
	self add: rbNoProxy.

	rbAutoProxy label: 'Auto-detect settings for this network' translateMe.
	rbAutoProxy font: QStyles smallControlFont.
	rbAutoProxy topLeft: 15@70.
	self add: rbAutoProxy.

	rbNamedProxy label: 'Manual proxy configuration:' translateMe.
	rbNamedProxy font: QStyles smallControlFont.
	rbNamedProxy topLeft: 15@98.
	self add: rbNamedProxy.

	label := CLabel on: 'Server:' translateMe.
	label topLeft: 27@118.
	self add: label.

	proxyServer topLeft: 80@118.
	proxyServer extent: 218@21; vResizing: #rigid.
	proxyServer disable.
	self add: proxyServer.

	label := CLabel on: 'Port:' translateMe.
	label topLeft: 310@118.
	self add: label.

	proxyPort topLeft: 350@118.
	proxyPort extent: 40@21; vResizing: #rigid.
	proxyPort disable.
	self add: proxyPort.

	rbProxyConfig label: 'Proxy configuration URL:' translateMe.
	rbProxyConfig font: QStyles smallControlFont.
	rbProxyConfig topLeft: 15@146.
	self add: rbProxyConfig.

	proxyConfigUrl topLeft: 29@166.
	proxyConfigUrl extent: 360@21 ; vResizing: #rigid.
	proxyConfigUrl disable.
	self add: proxyConfigUrl.

	acceptButton label: 'Accept' translateMe.
	acceptButton font: QStyles smallControlFont.
	acceptButton extent: 80@26.
	acceptButton position: 160@220.
	acceptButton roundCorners: true.
	self add: acceptButton.

	cancelButton label: 'Cancel' translateMe.
	cancelButton font: QStyles smallControlFont.
	cancelButton extent: 80@26.
	cancelButton position: 280@220.
	cancelButton roundCorners: true.
	self add: cancelButton.

	rbAutoProxy select. "the default"! !


!QQuickReference methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:23'!
setupCostume

	| content |
	super setupCostume.

	self title: 'Quick Reference' translateMe.
	self defaultExtent: 616@520;
		extent: 616@520;
		color: (Color white alpha:0.9);
		minExtent:616@520;
		maxExtent: 616@520;
		visible: false.

	content := CPlayer new.
	content color: (Color transparent);
		sticky: true;
		extent: (600@488);
		roundCornerSpec: #(2 3).
	self setupPanel: content.

	moreButton label: 'More Information...' translateMe;
		extent: 130@23;
		fullBounds;
		borderColor: (QColors paneBorderColor darker);
		bottomRight: 600@488.
	content add: moreButton.! !


!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'sn 5/8/2011 21:09'!
setupCostume
	super setupCostume.

	self defaultExtent: (580@300).
	self extent: (self defaultExtent).

	self setupBorderedPanel: siteList.
	(siteList layoutFrame) 
		rightFraction: 0.3;
		rightOffset: 0.
	(documents layoutFrame) 
		leftFraction: 0.3;
		leftOffset: 0.

	addButton 
		label: '+';
		font: (QStyles largeControlFont);
		textEmphasis: 1.
	self add: addButton.

	delButton
		label: '-';
		font: (QStyles largeControlFont);
		textEmphasis: 1.
	self add: delButton.

	self title: 'SharePoint Tool' translateMe! !


!QServiceChooser methodsFor: 'filters' stamp: 'sn 5/13/2011 13:13'!
onForumChoiceChanged	

	"Change in the filtering choice for the services list."

	forumChoices propertyValueAt: #categories 
				   put: (forumChoices selection propertyValueAt: #categories).

	self serviceListContents: (self forumSort: owner servicesPane allServices).

	forumChoices selection == templateRadio ifTrue: [
		loginButton label: 'Create Forum' translateMe
	] ifFalse: [
		loginButton label: 'Enter Forum' translateMe
	].

! !

!QServiceChooser methodsFor: 'private' stamp: 'sn 5/13/2011 13:11'!
msgCountingForums: nForums users: nUsers

	"Report usage from the point of view of the forums pane"
	| msg |

	msg := (nForums caseOf: {
			[0] -> ['No Forum is active.' translateMe].
			[1] -> ['One Forum is active.' translateMe].
		} otherwise: [ '', nForums, ' Forums are active.' translateMe]).

	msg := msg, ' ', (nUsers caseOf: {
				[0] -> [''].
				[1] -> ['One person is present.' translateMe].
			} otherwise: [ '', nUsers, ' ', 'people are present.' translateMe]).

	^ msg
! !

!QServiceChooser methodsFor: 'private' stamp: 'sn 5/13/2011 15:25'!
showTemplates: bShow

	"Show or hide the templates and Templates filter option.
	 Usually to reflect whether or not the user has admin powers."

	bShow ifTrue: [
		allForumsRadio propertyValueAt: #categories put: #(notNil).		"The filter"
		allForumsRadio balloonHelp: 'All Forums and templates.' translateMe.
		templateRadio visible: true.
	] ifFalse: [
		allForumsRadio propertyValueAt: #categories put: #(isForum).	"The filter"
		allForumsRadio balloonHelp: 'All Forums.' translateMe.
		templateRadio visible: false.
		templateRadio selected ifTrue: [ 
			templateRadio selected: false.  
			allForumsRadio selected: true ].
	].

	"If  All radio is selected, propagate the new filter (simulate a radio-select)
	 so a subsequent forumSort:  produces the filtered result."
	allForumsRadio selected ifTrue: [
			forumChoices propertyValueAt:#categories 
						   put: (allForumsRadio propertyValueAt:#categories)
	].! !

!QServiceChooser methodsFor: 'private' stamp: 'sn 5/13/2011 13:13'!
switchToServiceList
	"Switch the list to show forums rather than users."

	self remove: userList.
	userList cursor: 0.
	self add: serviceList.
	self remove: userChoices.	
	self add: forumChoices before: serviceList.

	updateServicesButton borderColor: (Color gray:0.4).
	updateUsersButton borderColor: (Color gray: 0.8).
	self remove: fakeTabDoober; add: fakeTabDoober after: serviceList.
	self placeFakeTabDoober.

	forumChoices selection == templateRadio ifTrue: [
		loginButton label: 'Create Forum' translateMe
	] ifFalse: [
		loginButton label: 'Enter Forum' translateMe
	].! !

!QServiceChooser methodsFor: 'private' stamp: 'sn 5/13/2011 13:12'!
switchToUserList
	"Switch the list to show users rather than forums."

	self remove: serviceList.
	self add: userList.
	serviceList cursor: 0.
	self remove: forumChoices.	
	self add: userChoices before: userList.

	updateUsersButton borderColor: (Color gray:0.4).
	updateServicesButton borderColor: (Color gray: 0.8).
	self remove: fakeTabDoober; add: fakeTabDoober after: userList.
	self placeFakeTabDoober.

	loginButton label: 'Enter Forum' translateMe! !

!QServiceChooser methodsFor: 'initialize' stamp: 'sn 5/13/2011 21:27'!
initialize
	super initialize.
	thinClient := false.

	self define: #logo as: CPlayer new.

	self define: #updateServicesButton as: CPushButton new.
	self define: #updateUsersButton as: CPushButton new.
	self define: #fakeTabDoober as: CPlayer new.
	self define: #details as: CTextEditor new.

	self define: #gmoButton as: CPushButton new.
	self define: #buyButton as: CPushButton new.
	self define: #loginButton as: CPushButton new.
	self define: #cancelButton as: CPushButton new.
	self define: #serviceList as: QGroupedList new.
	self define: #userList as: QGroupedList new.
	self define: #thumbnail as: CPlayer new.
	self define: #thumbLabel as: QInertLabel new.
	self define: #listFooter as: CLabel new.

	self define: #versionLabel as: (CLabel on: QwaqVersion current numericVersion).
	self define: #hostLabel as: CLabel new.
	self define: #loginLabel as: CLabel new.
	
	self define: #forumChoices as: CHolder new.
	self define: #userChoices as: CHolder new.

	self define: #prefsButton as: CPushButton new.

	self define: #orgChoices as: CDropDownList new.
	self define: #orgLabel as: (CLabel on: 'Organization:' translateMe).	

	self define: #tosLabel as: (CLabel on: '').
	self define: #helpButton as: QHelpButton new.
! !

!QServiceChooser methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:18'!
setupCostume

	super setupCostume.
	self visible: false.
	self sticky: true.
	self extent: (self defaultExtent).	
	self minWidth: (340).
	self minHeight: (360).
	QFloatingPane setupDialog: self.
	self dropShadowEnabled: false.
	self roundCorners: false.
	self graphicForm: (QForms find: 'PaneFill.gif'); graphicFit: #tile.
	self borderWidth: 0.

	orgLabel 
		font: QStyles largeControlFont;
		textEmphasis: 1;
		textColor: (QColors qwaqGray darker);
		hResizing: #shrinkWrap.
	self add: orgLabel.
	orgChoices 
		hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self add: orgChoices.

	orgChoices costume label 
		textEmphasis: 1;
		textFont: (StrikeFont familyName: #'LiberationMono' pointSize: 12);
		textColor: (QColors qwaqGray darker).

	tosLabel 
		hResizing: #shrinkWrap; vResizing: #shrinkWrap;
		textColor: (QColors qwaqGray darker).
	self add: tosLabel.

	updateServicesButton
		label: 'Forums' translateMe;
		font: QStyles controlFont;
	 	roundCornerSpec: #(1 4);
		borderColor: (Color gray:0.4).
	self add: updateServicesButton.

	updateUsersButton
		label: 'People' translateMe;
		font: QStyles controlFont;
		roundCornerSpec: #(1 4);
		borderColor: (Color gray: 0.8).
	self add: updateUsersButton.

	serviceList
		itemMaker: QServiceListItem;
		hResizing: #spaceFill;
		keepCursorInView: false;
		borderColor: (Color gray: 0.6);
		roundCornerSpec: #();
		hScrollable: false; vScrollable: nil. 	"On demand."
	QListClickListener installNewIn: serviceList.
	" self add: serviceList.  -- way below so it is top "

	self makeForumChoices.
	self add: forumChoices before: serviceList.

	userList
		itemMaker: QUserListItem;
		hResizing: #spaceFill;
		keepCursorInView: false;
		hScrollable: false; vScrollable: nil;	"On demand."
		roundCornerSpec: #();
		borderColor: (Color gray: 0.6).
	QListClickListener installNewIn: userList.
	"Self add: userList - deliberately not until chosen."

	self makeUserChoices.

	thumbnail
		borderWidth: 1; 
		borderColor: (Color gray: 0.75); 
		borderStyle: #simple;
		fillColor: (QColors paneColor);
		roundCornerSpec: #(4);
		graphicForm: nil.
	self add: thumbnail.
	thumbLabel
		fillColor: (Color r: 0.96 g: 0.94 b: 0.88  alpha: 0.7);
		label: '';
		textColor: (Color black);
		textInset: 5@2;
		textFont: (QStyles smallControlFont);
		hResizing: #shrinkWrap; vResizing: #shrinkWrap;
		roundCornerSpec: #(4);
		visible: false.
	self add: thumbLabel.

	details 
		color: (QColors paneColor lighter);
		borderWidth: 1; 
		borderColor: (Color gray: 0.75); 
		borderStyle: #simple;
		readOnly: true;
		fillColor: (QColors paneColor);
		textColor: (Color r: 0.1 g: 0.12 b: 0.22);
		vResizing: #rigid; hResizing: #spaceFill;
		hScrollable: false.
	self add: details.

	listFooter	
		label: '';
		textColor: (Color gray: 0.1);
		textFont: (QStyles smallTextFont);
		textOffset: (2@0);
		fillColor: Color transparent;
		borderWidth: 0; 
		hResizing: #rigid; vResizing: #rigid.
	self add: listFooter.

	loginButton
		disable;
		label: 'Enter Forum' translateMe;
		font: QStyles controlFont;
		roundCorners: true;
		textEmphasis: 1.
	self add: loginButton.

	cancelButton
		label: 'Log Out' translateMe;
		font: QStyles controlFont;
		roundCorners: true.
	self add: cancelButton.

 " Top decorations..."
	logo color: (QColors paneColor lighter);
		 borderWidth: 1;
	 	 borderStyle: #simple;
		 borderColor: (QColors qwaqGray lighter);
		 graphicForm: (QForms openqwaqLogoClear42);
		 graphicAnchorPoint: #leftCenter;
		 graphicOffset: (3@1);
		 extent: (self width @ 47).
	self add: logo.

	prefsButton 
		label: 'Preferences...' translateMe;
		font: QStyles controlFont;
		roundCorners: true;
		balloonHelp: 'Edit your personal information and settings.' translateMe.
	self add: prefsButton.

	helpButton
		label: 'Help...' translateMe;
		ui: owner;
		partialUrl:  (QwaqParticipantUI versionedUserGuide: 'lobby_window_overview').
	self add: helpButton.

	gmoButton 
		label: 'Get My Own...' translateMe;
		font: QStyles controlFont;
		roundCorners: true;
		visible: false	;	"Until properly positioned via updateGMOButton"
		balloonHelp: 'Create a new trial organization.' translateMe.
	self add: gmoButton.

	buyButton 
		label: 'Buy Now...' translateMe;
		font: QStyles controlFont;
		roundCorners: true;
		visible: false.
	self add: buyButton.

	self add: serviceList.
	fakeTabDoober
		borderWidth: 1; 
		borderStyle: #simple; 
		borderColor: (Color gray:0.825).
	self add: fakeTabDoober.

	{ hostLabel . loginLabel .  versionLabel } do: [ : lbl |
		lbl font: QStyles smallControlFont;
			 textColor: (QColors qwaqGray darker);
			 hResizing: #shrinkWrap;
			 vResizing: #shrinkWrap.
		self add: lbl.
	].

	self layoutEverything.
	self setupReturnAcceleration.

	
! !


!QServiceListItem methodsFor: 'private' stamp: 'sn 5/13/2011 21:30'!
logicalContainer

	"Ugh.. dead reckon to whichever container I'm in,
	 this is the recipient of my double-click relays."

	| c |
	c := self container.
	[ c ] whileNotNil: [
		(c isKindOf: QServicesPane) ifTrue: [
		 	^ c
		].
		(c isKindOf: QServiceChooser) ifTrue: [ 
			^ c
		].
		(c isKindOf: KrServiceChooser) ifTrue: [
		 	^ c
		].
		c := c container.
	].
	^ nil! !


!QServicesPane methodsFor: 'menus' stamp: 'sn 5/13/2011 15:26'!
forumMenuInto: menu
	"Fill a CMenu with the available forums (services).  Omits the one I'm in right now.
       Follows the sorting order of the services pane.
	 Clipped to at most 18, offers a All Forums... command 
	 to bring up this tool for full searching.."

	|  tmpList  lbl item |
	menu menuItems removeAll.
	item := nil.
	(allServices size > 1) ifFalse: [ 	
		menu add: 'All Forums...' translateMe target: owner action: #showServicesPane.
		QStyles installMenuFontInMenu: menu.
		^menu
	].

	tmpList := (allServices select: [ :svc | svc isTemplate not ]) asArray.
	tmpList := tmpList sortBy: [:a :b | (self svcCompare: a to: b)].
	(tmpList size < 2) ifTrue: [ 
		menu add: 'All Forums...' translateMe target: owner action: #showServicesPane.
		QStyles installMenuFontInMenu: menu.
		^menu
	].

	tmpList := tmpList allButFirst.	"First is this forum"
	1 to: (tmpList size min:18) do: [ : i |
		| svc |

		svc := tmpList at: i.
		(i > 1 and: [svc category > ((tmpList at: (i-1)) category)]) ifTrue: [
			item separator: true.
		].

		"And list this item."
		lbl := svc name,
			   (svc userNames size caseOf: {
				[ 0 ] -> [''] .
				[ 1 ] -> [' (1 Person)'] 
			} otherwise: [ ' (', svc userNames size, ' People)' ]).
		item := menu add: lbl
					target: self action: #placeMenuTeleportTo: argument: svc.
		item costume normalTextColor: svc textColor.
	].

	menu addSeparator.
	menu add: 'All Forums...' translateMe target: owner action: #showServicesPane.
	QStyles installMenuFontInMenu: menu.
	^menu
! !

!QServicesPane methodsFor: 'menus' stamp: 'sn 5/13/2011 22:17'!
logOut: entry

	| msg mins needSave dlog |

	entry ifNil: [ ^ self ].
	needSave := false.
	msg := 'Log out of ',  entry name, '?'.
	(owner canModifyForum and: [owner preferences doAutoSave not]) ifTrue: [

		entry needsSave ifTrue: [

			needSave := true.
			mins := (((Time utcSeconds) - entry lastSaveTime) // 60) max: 1.
			mins < 120 ifTrue: [
				msg := msg, 
					String cr, String cr,
					'Last saved ', mins, ' minute', ((mins == 1) ifTrue: [' ago.'] ifFalse: ['s ago.']).
			] ifFalse: [
				mins // 60 <  24 ifTrue: [
					msg := msg,
						String cr, String cr,
						'Last saved over ', (mins//60), ' hours ago.' ].
			].
			msg := msg, String cr,
					'Auto-save is disabled in your preferences.', String cr.
		].
	].

	dlog := CUserDialog new.
	dlog label: 'Confirm' translateMe.
	dlog message: msg.
	dlog messageText allowEditing: false.
	dlog messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	needSave ifTrue: [
		(dlog addButton: 'Save and Log Out' translateMe value: #save)
			width: 120.
		(dlog addButton:  'Log Out, Don''t Save' translateMe value: #quit)
			width: 133.
	] ifFalse: [
		(dlog addButton: 'Log Out' translateMe value: #quit)
	].
	dlog addButton: 'Cancel' translateMe value: #cancel.

	(dlog run: nil centerAt: nil) caseOf: {
		[#save] -> [ owner saveForum: entry svcRecord.  owner deactivateService: entry url ].
		[#quit ] -> [ owner deactivateService: entry url. ]
	} otherwise: [ ].

 ! !

!QServicesPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:53'!
setupCostume
	super setupCostume.

	self title: 'Forums' translateMe.
	self defaultExtent: 320@240.
	self minExtent: 240@(60 + (self footerHeight)).
	self extent: self defaultExtent.

	self makeFilterChoices.
	filterChoices hResizing: #spaceFill.
	filterChoices width: 100.
	self add: filterChoices.

	serviceList
		color: (Color white);
		borderColor: (Color gray alpha: 0.3);
		itemMaker: QServiceListItem;
		keepCursorInView: false;
		hScrollable: false; 
		vScrollable: nil. 	"On demand."

	QListClickListener installNewIn: serviceList.
	self setupBorderedPanel: serviceList.
	panel layoutFrame bottomFraction: 1 offset: ((self footerHeight + 1 + inset) negated).	
			"Room for footer - see also layoutFooter"

	footerBox
		borderWidth: 0; borderStyle: #simple;
		fillColor: (QColors paneColor lighter alpha: 0.5).
	self add: footerBox. 
		
	thumbnail
		borderWidth: 0; borderStyle: #simple;
		fillColor: (Color transparent).
	self add: thumbnail.

	listFooter
		label: '';
		hResizing: #rigid; vResizing: #rigid;
		textColor: (Color black);
		textAnchorPoint: #topLeft;
		textInset: 4@-1;
		textFont: (QStyles smallTextFont).
	self add: listFooter.

	! !


!QSessionRecorderPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:32'!
setupCostume
	| |
	super setupCostume.

	self title: 'Session Recorder' translateMe.

	recordButton label: 'Record' translateMe;
		font: QStyles controlFont;
	 	extent: 75@25;
		fullBounds;
		topLeft: 6@244;
		width: 242;
		roundCorners: true.
	panel add: recordButton.

	panel layoutFrame bottomOffset: (panel layoutFrame bottomOffset - (self footerHeight)).
	self setupFooter.
! !


!QSessionWebcastPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:29'!
setupCostume
	| lbl |
	super setupCostume.

	self title: 'Session Webcast' translateMe.

	"preview extent: 285@190."
	preview left: 255.
	preview extent: 240@160.

	lbl := CLabel on: 'Name:' translateMe.
	lbl topLeft: 5@62;
		hResizing: #shrinkWrap;
		fullBounds.
	panel add: lbl.

	broadcastNameEditor
		topLeft: 77@62;
		hResizing: #rigid;
		width: 170.
	panel add: broadcastNameEditor.

	lbl := CLabel on: 'Description:' translateMe.
	lbl topLeft: 5@86;
		hResizing: #shrinkWrap;
		fullBounds.
	panel add: lbl.

	broadcastDescriptionEditor
		font: QStyles controlFont;
		color: Color white;
		hResizing: #rigid;
		width: 237;
		height: 66;
		topLeft: 8@104;
		hScrollable: false;
		fullBounds.
	panel add: broadcastDescriptionEditor.

	broadcastButton label: 'Start' translateMe;
		font: QStyles controlFont;
	 	extent: 75@25;
		fullBounds;
		topLeft: 8@(broadcastDescriptionEditor bottom + 16);
		width: 75;
		roundCorners: true.
	panel add: broadcastButton.

	broadcastURLLabel topLeft: 5@(broadcastButton bottom + 16);
		hResizing: #shrinkWrap;
		fullBounds.
	"panel add: broadcastURLLabel."

	self setBroadcastURL: nil.
	broadcastURL 
		topLeft: 85@188;
		hResizing: #shrinkWrap;
		font: (QStyles textFont);
		fullBounds.
	panel add: broadcastURL.

"
	panel layoutFrame bottomOffset: (panel layoutFrame bottomOffset - (self footerHeight)).
"! !


!QSoundDialog methodsFor: 'utilities' stamp: 'sn 5/13/2011 22:54'!
announceMicrophoneStatus
	"Tell the user about the microphone operational state."
	| controlBar msg |
	controlBar := owner controlBar.
	controlBar microphone selected ifTrue: [
		owner audioSession ifNotNilDo: [:a |
			a isPressToTalk
			ifTrue: [msg := 'Microphone is on Push-to-talk. Press control key to speak.' translateMe]
			ifFalse: [msg := 'Microphone is on. Click icon to mute.' translateMe]
		]
	] ifFalse: [
		msg := 'Microphone is off. Click icon to speak.' translateMe 
	].
	controlBar microphoneMessage: msg.! !


!QSpeakerManager methodsFor: 'events' stamp: 'sn 5/13/2011 22:58'!
beMute
	mutex critical: [
		isMute ifFalse: [
			isMute := true.
			view ifNotNil: [ view owner statusInfo: 'Audio output is off.' translateMe ].
			speakers do: [:spk | spk mutingChanged ].	
		]].! !

!QSpeakerManager methodsFor: 'events' stamp: 'sn 5/13/2011 22:58'!
beUnmute
	mutex critical: [
		isMute ifTrue: [
			isMute := false.
			view ifNotNilDo: [:v | v owner statusInfo: 'Audio output is on.' translateMe].
			speakers do: [:spk | spk mutingChanged ].
		]].! !


!QSpeakerMenuButton methodsFor: 'tips' stamp: 'sn 5/13/2011 22:59'!
onSpeakerEnter

	<on: mouseEnter in: self>
	
 	self owner audioSession ifNil: [ ^ self ].
	self owner statusInfo: (
		self selected 
			ifTrue: [ 'Audio output is on.' translateMe]
			ifFalse: [ 'Audio output is off.' translateMe]).! !


!QStatisticsPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:42'!
setupCostume

	super setupCostume.

	self title: 'Performance Statistics' translateMe.
	self defaultExtent: 310@242;
		extent: self defaultExtent.
	self minExtent: 310@130.

	gcPanel := CPlayer new.
	gcPanel color: (Color white alpha: 0.6);
		sticky: true;
		borderWidth: 1; borderStyle:#simple; borderColor: (Color gray: 0.6);
		roundCornerSpec: #(2 3).
	self add: gcPanel.

	logText color: (Color white alpha:0.8).
	logText borderWidth: 1; borderStyle:#simple; borderColor: (Color gray: 0.5).
	logText allowEditing: false.

	self add: logText.

	incGCs hResizing: #shrinkWrap.
	self add: incGCs.

	fullGCs hResizing: #shrinkWrap.
	self add: fullGCs.

	tenures hResizing: #shrinkWrap.
	self add: tenures.

	self add: watcher.

	{fullGCs . incGCs . tenures . watcher } 
	 do: [ : elem | elem 	font: (QStyles smallTextFont) ]! !


!QStickyNote methodsFor: 'accessing' stamp: 'sn 5/13/2011 22:36'!
floatingMessageFor: anAvatar

	"Adjust the floating message according to whether I can edit or not,
	 whether there's a persisted creator and/or last-mod date, etc."

	| date tail msg front |
	self lastModifiedTime ifNotNil: [
		date := QStyles dateStringFromUTC: self lastModifiedTime.
	].

	tail := (self editableByUser: anAvatar)
			ifTrue: [ 'Double-click to edit.' translateMe ]
			ifFalse: [ 'Double-click to review.' translateMe].

	front := self creatorLogin ifNotNil: [
					(self creatorLogin = (anAvatar userLogin)) ifTrue: [
						'Note by You' translateMe
					] ifFalse: [
						'Note by' translateMe, ' ', (self creatorName)
					].
				] ifNil: [
					'Note' translateMe.
				].

	msg :=	self creatorLogin ifNotNil: [
				date ifNotNil: [
					front, '\', date, '\', tail
				] ifNil: [
					front, '\', tail
				]
			] ifNil: [
				date ifNotNil: [
					front, '\', date, '\', tail
				] ifNil: [
					front, ' - ', tail
				]
			].

	^ msg
! !


!QStreamingVideoPlayerUI methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:19'!
setupCostume
	| buttonFont |

	super setupCostume.
	self setupColors.
	self roundCorners: false.
	self borderStyle: #simple.
	self borderWidth: 1.

	buttonFont := (StrikeFont familyName: #'LiberationMono' pointSize: 14).
	
	playButton font: buttonFont; label: 'Play' translateMe.
	playButton extent: 68@23; roundCorners: false;
				hResizing: #rigid; vResizing: #rigid.
	loopButton extent: 22@22; 
		fillAlpha: 0;
		graphicAnchorPoint: #center;
		graphicFit: #scale;
		borderWidth: 1; borderColor: (Color gray:0.05);
		normalImage: (QForms current import: 'Looping-Off.png' from: 'icons/Qwaq');
		selectedImage: (QForms current import: 'Looping-On.png' from: 'icons/Qwaq').
	
	self 
		add: playButton;
		add: loopButton;
		add: seekSlider;
		add: volumeSlider;
		add: volumeLabel;
		add: currentTimeLabel.

	volumeLabel width: 80.
	volumeLabel font: (StrikeFont familyName: #'LiberationMono' pointSize: 11).
	"You'd think that using #volumeString would work (instead of hard-wiring it), 
	 but it doesn't... I don't understand why."
	volumeSlider value: 10.
	volumeLabel value: (self volumeString).

	currentTimeLabel font: (StrikeFont familyName: #'LiberationMono' pointSize: 11).
	currentTimeLabel value: '0:00:00'.

	self doLayout.
! !


!QStyles class methodsFor: 'initializing' stamp: 'sn 5/7/2011 18:27'!
defaultStyles
	"These are the core system styles always preloaded at instance creation time."
	(TextConstants includesKey: #'LiberationMono') ifTrue: [
		^ self defaultStylesWithLM.
	].

	(TextConstants includesKey: #'Lucida Grande') ifTrue: [
		^ self defaultStylesWithLG.
	].


	^ Dictionary newFromPairs: {
		#AnnotationStyle . 	"QLabel2D" 
				(QStyles style: #BitstreamVeraSans size: 12) .

		#SmallControlStyle . 	"Participant controls."  
				(QStyles style:  #BitstreamVeraSans size: 9) .
		#ControlStyle . 		"Participant controls."  
				(QStyles style:  #BitstreamVeraSans size: 10) .
		#LargeControlStyle	. "Headline labels." 
				(QStyles style: #BitstreamVeraSans size: 13) .

		#SmallListStyle. 		"List items."
				(QStyles style:  #BitstreamVeraSans size: 9) .
		#ListStyle. 		"List items."
				(QStyles style: #BitstreamVeraSans size: 10).

		#SmallTextStyle .	"Bulk text"
				(QStyles style: #BitstreamVeraSans size: 9).
		#TextEditStyle .		"Various multiline text areas."
				(QStyles style: #BitstreamVeraSans size: 11).

		#LabelStyle	.		"QLabel" 		
				((QStyles style: #BitstreamVeraSans size: 16) centered; yourself) .

		"The font size controls the -quality- of a sign or note, not its size.
		  Smaller allows longer notes to stay within the 'true-size' range."
		#SignStyle	.		"QDisplaySign" 		
				((QStyles style: #BitstreamVeraSans size: 30) centered; yourself) .
		#NoteStyle	.		"QStickyNote" 		
				((QStyles style: #BitstreamVeraSans size: 13) yourself) .
		#CardStyle	.		"Topic cards, etc."
				((QStyles style: #BitstreamVeraSans size: 13) yourself) .

		#TMenuStyle	.	 "In-space menu rendering" 
				(QStyles style: #BitstreamVeraSans size: 16) .

		#AvatarLabelStyle .	"Variable-size labels above avatars."
				(TextStyle named: #BitstreamVeraSans)
	}.! !


!QToolPane class methodsFor: 'accessing' stamp: 'sn 5/13/2011 13:20'!
titleFont
	(TextConstants includesKey: #'LiberationMono') ifTrue: [
		^ (TextConstants at: #'LiberationMono')  fontOfPointSize: 12
	] ifFalse: [
		^ QStyles controlFont
	]! !


!QTrafficPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 19:39'!
setupCostume

	| label |
	super setupCostume.
	self fillAlpha: 0.8.

	self title: 'Network Activity' translateMe.
	self defaultExtent: 330@180.
	self extent: self defaultExtent.

	"The legend labels take their text from the router constants,
	 and their color from the traffic-watcher color table."

	1 to: (TRouterConstants numTrafficTags) do: [ :i|
		label := CLabel on: (TRouterConstants tagName: i).
		legendLabels at: i put: label.
		label hResizing: #shrinkWrap.
		label textColor: (watcher colorTable at: i) muchDarker.
		label font: (QStyles smallControlFont).
		self add: label.
	].
	self layoutLegend.

	watcher plotStyle: #strip.
	summaryLabel font: (QStyles smallTextFont).
	summaryLabel hResizing: #rigid.
	peakLabel font: (QStyles smallTextFont).
	peakLabel hResizing: #shrinkWrap.
	peakLabel balloonHelp: 'Click to change the timespan.' translateMe.

	plotLabel font: (QStyles smallTextFont).
	plotLabel hResizing: #shrinkWrap.
	plotLabel balloonHelp: 'Click to change the plot style.' translateMe.
	self add: watcher.
	self add: peakLabel.
	self add: summaryLabel.
	self add: plotLabel.! !


!QUserListItem methodsFor: 'private' stamp: 'sn 5/13/2011 21:30'!
logicalContainer
	"Ugh.. dead reckon to whichever tool I'm in,
	 this is the recipient of my double-click relays."
	| c |
	c := self container.
	[ c ] whileNotNil: [
		(c isKindOf: QUsersPane) ifTrue: [
		 	^ c
		].
		(c isKindOf: QServiceChooser) ifTrue: [ 
			^ c
		].
		(c isKindOf: KrServiceChooser) ifTrue: [
		 	^ c
		].
		c := c container.
	].
	^ nil! !


!QUsersPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:11'!
setupCostume
	super setupCostume.

	self borderColor: (QColors mainBorderColor).
	self title: 'People' translateMe.
	self titleWrapper fillAlpha: 0.95.	"Since things slide behind when getting small."
	self fillColor: (QColors paneColor).
	self userDraw: true.

	userList color: (QColors paneColor);
		borderColor: (Color transparent);
		borderWidth: 1;
		itemMaker: QUserListItem;
		keepCursorInView: false;
		vScrollable: nil.		"On demand."
	self add: userList.
	QListClickListener installNewIn: userList.

	details color: (QColors paneColor slightlyDarker);
		borderColor: (Color transparent);
		borderWidth: 1;
		textColor: (Color r: 0.1 g: 0.12 b: 0.22);
		readOnly: true;
		vResizing: #rigid; hResizing: #spaceFill;
		hScrollable: false.
	self add: details.

	self makeFilterChoices.
	filterChoices hResizing: #spaceFill;
		width: 110.
	self add: filterChoices.

	goToButton label: ':';
		textFont: (QToolPane titleFont);
		textEmphasis: 1;
		balloonHelp: 'Go join the selected user.' translateMe;
		disable.
	self addStripButton: goToButton.
	goByButton label: ':';
		textFont: (QToolPane titleFont);
		textEmphasis: 1;
		balloonHelp: 'Go stand beside the selected person, and tag along with them.' translateMe;
		heading: 90;
		costume;
		disable.
	goByButton costume fillStyle: #horizontalGradient.
	self addStripButton: goByButton.
	goByButton extent: (goByButton extent y @ goByButton extent x).

	textUserButton label: 't' translateMe;
		textFont: (QToolPane titleFont);
		textEmphasis: 1;
		balloonHelp: 'Send private text to the selected person.' translateMe;
		disable.
	self addStripButton: textUserButton.

	self addStripSeparator.
	favButton label: '*';
		textFont: (QStyles controlFont);
		textEmphasis: 1;
		balloonHelp: 'Add or remove the selected person from your Favorites' translateMe;
		disable.
	self addStripButton: favButton.
	self addStripSeparator.
	newUserButton label: 'Invite New User' translateMe;
		textFont: (QStyles smallControlFont);
		textEmphasis: 0;
		balloonHelp: 'Invite a new user\to this organization.' translateMe withCRs;
		disable.
	self addStripButton: newUserButton.
	newUserButton hResizing: #rigid; width: 89.

	faceFloat 
		borderWidth: 1;
		borderColor: (CWidgetLibrary default selectionColor alpha: 0.9);
		borderStyle: #simple;
		fillColor: (QColors paneColor alpha: 0.5);
		extent: 52@52;
		visible: false.

	"Initialize this directly, since lastActivity:  reasons about deltas."
	self propertyValueAt: #lastActivity 
		put: (Time millisecondClockValue) 
		with: #lastActivityChanged.
! !


!QVideoFeedPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:57'!
setupCostume

	super setupCostume.
	self title: 'Video Feeds' translateMe.
	self inset: 0.
	scroller := QVideoFeedScrollPane new.
	scroller 
		color: (Color white alpha: 0.2);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		vScrollable: false;		"Initially horizontal"
		hScrollable: nil;
		borderWidth: 0.
	list := QVideoFeedPaneList new.
	list layoutFrame: CLayoutFrame new.
	list layoutFrame
				leftFraction: 0; 
				rightFraction: 1; 
				topFraction: 0; 
				bottomFraction: 1.
	scroller add: list.
	self setupPanel: scroller.
	list costume.
	self startScript: #onItemsChanged when: { list asPrimCostume . #structureChanged }.

	"Suppress the title, as it adds little and takes up too big a swathe."
	titleBox visible: false.
	titleWrapper visible: false.! !


!QwaqAbout methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:17'!
setupCostume

	super setupCostume.
	self extent: 430@350.

	QFloatingPane setupDialog:self.
	self fillAlpha: 0.95.

	logo color: (QColors paneColor lighter);
		 borderWidth: 1;
	 	 borderStyle: #simple;
		 borderColor: (QColors qwaqGray lighter);
		 graphicForm: (QForms openqwaqLogoClear42);
		 graphicAnchorPoint: #leftCenter;
		 graphicOffset: (6@2);
		 roundCornerSpec: #(1 4).
	self add: logo.

	serviceName font: QStyles smallControlFont.
	serviceName hResizing: #shrinkWrap.
	self add: serviceName.

	serviceHost font: QStyles smallControlFont.
	serviceHost hResizing: #shrinkWrap.
	serviceHost hResizing: #shrinkWrap.
	self add: serviceHost.

	userLogin font: QStyles smallControlFont.
	userLogin hResizing: #shrinkWrap.
	self add: userLogin.

	tosLabel font: QStyles smallControlFont;	
		hResizing: #shrinkWrap.
	self add: tosLabel.

	licenseText allowEditing: false.
	licenseText extent: (self width-31) @ (self height - 185).
	licenseText fillAlpha: 1.0.
	self add: licenseText.

	versionLabel 
		 font: QStyles controlFont;
		 textColor: (Color gray: 0.1);
		 hResizing: #shrinkWrap.
	self add: versionLabel.

	okButton label: 'OK' translateMe.
	okButton font: QStyles controlFont.
	okButton extent: 80@25.
	okButton roundCorners: true.
	okButton fullBounds.
	self add: okButton.

	self layoutEverything.! !


!QwaqLogin methodsFor: 'events' stamp: 'sn 5/13/2011 13:21'!
onContextMenu
	"Context menu - proxy configuration."

	| menu |

	<on: yellowButtonDown>

	menu := CMenu new.
	menu add: 'Proxy Configuration...' translateMe target: self action: #editProxyConfiguration.
	QStyles installMenuFontInMenu: menu.
	menu openAt: hand position.! !

!QwaqLogin methodsFor: 'events' stamp: 'sn 5/13/2011 13:23'!
showOptionalFields: bShow
	"Expand/retract the optional fields area (organization and host)"
	bShow ifFalse: [
		"Take it away."
		moreButton label: 'More Options...' translateMe.
		moreButton roundCornerSpec: #(1 2 3 4).
		self remove: moreContent.
		self extent: self class lessExtent.
	] ifTrue: [
		"Show it"
		moreButton label: 'Hide Options...' translateMe.
		moreButton roundCornerSpec: #(1 4).
		self add: moreContent.
		self extent: self class moreExtent.
	].

	self startScript: #onSizeChosen.
	self placeBottomButtons.! !

!QwaqLogin methodsFor: 'initialize' stamp: 'sn 5/14/2011 16:08'!
initialize
	super initialize.

	self define: #logo as: CPlayer new.
	self define: #title as: CLabel new.
	self define: #organization as: CInputField new.
	self define: #userInput as: CInputField new.
	self define: #password as: CInputField new.
	self define: #loginButton as: CPushButton new.
	self define: #cancelButton as: CPushButton new.
	self define: #savePassword as: CCheckBox new.
	self define: #serverList as: CDropDownList new.
	self define: #proxyDlg as: QProxyDialog new.
	self define: #motd as: QMessageOfTheDay new.
	self define: #helpButton as: QHelpButton new.
	self define: #plusServerButton as: CPushButton new.
	self define: #forgotButton as: CPushButton new.	
	self define: #moreButton as: CPushButton new.
	self define: #moreContent as: CPlayer new.
	self define: #versionLabel as: (CLabel on: QwaqVersion current numericVersion).
	self define: #hostLabel as: CLabel new.
	self define: #orgLabel as: CLabel new.
	self define: #moreLabel as: CLabel new.
	self define: #pwdLabel as: CLabel new.
	self define: #userLabel as: CLabel new.
	self define: #topSurround as: CPlayer new.
	self define: #proxyBtn as: CPushButton new.
	self define: #footer as: (CLabel on: '').

	moreButton label: 'More Options...' translateMe.	"So we don't have to set it in setup costume,
	 									 which conflicts with toggling it when savedLogin is loaded."

	userInput value: '(E-Mail or User ID)'.
	password value: ''.
	organization value: '(Optional)'.

	userInput autoAccept: true.
	password autoAccept: true.
	organization autoAccept: true.

	proxyDlg loadProxySettings.! !

!QwaqLogin methodsFor: 'initialize' stamp: 'sn 5/13/2011 20:37'!
setupCostume
	super setupCostume.
	self extent: (self class lessExtent).		"See also QMessageOfTheDay (same width)"
	QFloatingPane setupDialog: self.
	self sticky: false; floating: false.
	self roundCorners: false.
	self dropShadowEnabled: false.
	self graphicForm: (QForms find: 'PaneFill.gif'); graphicFit: #tile.
	self borderWidth: 0.

	topSurround
		fillColor: (QColors paneColor);
		roundCorners: true;
		borderWidth: 1; 
		borderColor: (Color gray: 0.75); 
		borderStyle: #simple;
		fullBounds.
	self add: topSurround.
	"The surround of the optional org/host fields..."
	moreContent
		fillColor: (QColors paneColor);
		borderWidth: 1; 
		borderColor: (Color gray: 0.75); 
		borderStyle: #simple;
		roundCornerSpec: #(2 3 4).
	moreButton 
		"label is set in #initialize so early state-changes during app initialize can work."
		 font: QStyles controlFont;
		 fullBounds;
		 roundCorners: true.
	self add: moreButton.

	userLabel := CLabel on: 'Login (E-Mail):' translateMe.
	userLabel font: QStyles controlFont;
		hResizing:  #spaceFill; fullBounds.
	self add: userLabel.

	userInput textOffset: 1@2.
	self add: userInput.

	pwdLabel := CLabel on: 'Password:' translateMe.
	pwdLabel font: QStyles controlFont.
	pwdLabel hResizing: #shrinkWrap; fullBounds.
	self add: pwdLabel.
	password editor font: (StrikeFont passwordFontSize: userInput textFont height).
	password textOffset: 1@1.
	self add: password.

	forgotButton 
		 label: 'Forgot Password?' translateMe;
		 font: QStyles controlFont;
		 roundCorners: true.
	self add: forgotButton.

	savePassword label: 'Remember Password' translateMe;
		font: QStyles controlFont;
		hResizing: #shrinkWrap.
	savePassword costume layout listDirection: #leftToRight.
	self add: savePassword.

	moreLabel := CLabel on: 'Fill in your organization details here\if your instructions include them.' translateMe withCRs.
	moreLabel font: QStyles controlFont.
	moreLabel hResizing: #shrinkWrap; fullBounds.
	moreLabel textEmphasis: 0.
	moreLabel textColor: (QColors qwaqGray darker).
	moreContent add: moreLabel.

	orgLabel := CLabel on: 'Organization:' translateMe.
	orgLabel font: QStyles controlFont.
	orgLabel hResizing: #shrinkWrap; fullBounds.
	orgLabel textColor: (Color gray: 0.15).
	moreContent add: orgLabel.
	moreContent add: organization.
	organization textOffset: 1@2.

	hostLabel := CLabel on: 'Host:' translateMe.
	hostLabel font: QStyles controlFont.
	hostLabel hResizing: #shrinkWrap; fullBounds.
	hostLabel textColor: (Color gray: 0.15).
	moreContent add: hostLabel.
	serverList hResizing: #spaceFill.
	serverList autoAccept: true.
	serverList height: 21.
	moreContent add: serverList.

	plusServerButton
		label: ' +';
		textInset: 3;
		font: QStyles controlFont.
	moreContent add: plusServerButton.

	proxyBtn 
		label: 'Proxy...' translateMe;
		textInset: 2;
		font: QStyles controlFont.
	moreContent add: proxyBtn.

	loginButton label: 'Login' translateMe.
	loginButton font: QStyles controlFont.
	loginButton roundCorners: true.
	loginButton fullBounds.
	loginButton textEmphasis: 1.
	self add: loginButton.

	cancelButton label: 'Exit' translateMe.
	cancelButton font: QStyles controlFont.
	cancelButton fullBounds.
	cancelButton roundCorners: true.
	self add: cancelButton.

	self placeBottomButtons.

 " Top decorations..."
	logo color: (QColors paneColor lighter);
		 borderWidth: 1;
	 	 borderStyle: #simple;
		 borderColor: (QColors qwaqGray lighter);
		 graphicForm: (QForms openqwaqLogoClear42);
		 graphicAnchorPoint: #leftCenter;
		 graphicOffset: (3@1);
		 extent: (self width @ 47).
	self add: logo.

	title value: 'Welcome to OpenQwaq!!' translateMe.
	title font: QStyles largeControlFont;
		textEmphasis: 1;
		textColor: (QColors qwaqGray slightlyDarker).
	self add: title.

	versionLabel 
		 font: QStyles controlFont;
		 textColor: (QColors qwaqGray slightlyDarker);
		 hResizing: #shrinkWrap.
	self add: versionLabel.
	helpButton 
		label: 'Help...' translateMe;
		ui: owner;
		partialUrl:  (QwaqParticipantUI versionedUserGuide: 'logging_in_openqwaq').
	self add: helpButton.
	footer 
		label: '';
		font: (QStyles smallTextFont);
		textFont: (QStyles smallTextFont);
		hResizing: #rigid;
		height: 16;
		vResizing: #rigid.
	self add: footer.

	self layoutEverything.
	self updateServerList.
	self setupReturnAcceleration.! !


!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:45'!
actionsMenu
	| menu |
	"The empty starting point for the space verbs (actions) menu."

	menu := CMenu new.
	menu add: 'Action...' translateMe target: self action: #noSuchAction.
	self runScript: #updateActionsMenu when: {menu . #open}.

	^menu! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:43'!
addSubMenusTo: aMenu
	{
		{'File' translateMe. self fileMenu}.	
		{ 'Edit' translateMe . self editMenu }.
		{'View' translateMe. self viewMenu }.
	   	{'Meeting' translateMe. self meetingMenu } . 
		{'Tools' translateMe. self toolsMenu}.
		{'Actions' translateMe. self actionsMenu}.
		{'Forums' translateMe. self forumsMenu}.

		{'Extras' translateMe. self extrasMenu}.
		{'Developer' translateMe. self magicDeveloperMenu}.
		{'Help' translateMe. self helpMenu }.

	} do:[:spec|
		spec last ifNotNil:[
			aMenu add: spec first subMenu: spec last.
		].
	].! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:34'!
extrasMenu
	| menu item subMenu |

	menu := CMenu new.

	(menu add: 'Ignore Gravity (Fly)' translateMe target: self action: #toggleRespectForTheLaw) 
		checked: false;
		separator: true;
		tag: #ignoreMotionRules.

	menu addSeparator.
		(menu add: 'Forum Details...' translateMe target: self action: #editForumDetails) tag: #extrasForumDetails.

	(menu add: 'Set Home Position...' translateMe target: self action: #makeThisTheHomePosition) tag: #extrasEntryPosition.

	"The following are both less useful now that we're using remote XML all the time,
	 and not up to date with current controller/session connectivity."
	"menu add: 'Test Persistence' target: self action: #persistenceTest."
	"menu add: 'Test Reconnect' target: self action: #reconnectTest."

	menu addSeparator.
	(menu add: 'Reset Sound' translateMe target: self action: #extrasResetSound)
		separator: true.

	subMenu := CMenu new.
	subMenu add: 'Mono Sound' translateMe target: self action: #testBuiltinSound.
	subMenu add: 'Spatial Sound' translateMe target: self action: #testOpenALSound.
	subMenu add: 'Voice Transport' translateMe target: self action: #testVoiceTransportRepeatedly.
	subMenu add: 'Voice Transport with .wav file' translateMe target: self action: #testVoiceTransportRepeatedlyWithUserFile.
	subMenu add: 'Client Experience' translateMe target: self action: #testClientExperience.

	subMenu addSeparator.
	subMenu add: 'OpenQwaq Multi-Share' translateMe target: self action: #placeXSetRootCard.
	subMenu addSeparator.
	subMenu add: '360 Rendering' translateMe target: self action: #render360.
	(menu add: 'Test' translateMe subMenu: subMenu) tag: #extrasTestMenu.

	menu addSeparator.
	item := menu add: 'Clear Resource Cache' translateMe target: self action: #emptyCache.
	item tag: #emptyCache.

	menu addSeparator.
	(menu add: 'Change Password...' translateMe target: self action: #changeUserPassword) tag: #extrasChangePassword.

	self runScript: #updateExtrasMenu when: {menu . #open}.

	^menu
! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:34'!
fileImport

	| fileToImport |

	self readyForEvents ifFalse: [ ^ self ].
	self canModifyForum ifFalse: [ ^ self ].

	[
		"Native dialog if available.  The file types supported are an open-ended set,
	       so we allow anything at the chooser and then get more specific in the dropFile: method."
		fileToImport := QFileDialog openFile: {
				{'Documents' . '*.*'} }
			label: 'Choose a File to Import' translateMe.
	] on: Error do: [
		^self inform: 'Could not open file chooser.'
	].

	fileToImport ifNotNil: [
		| f | 
		[
			QActivityCapture action: #ImportFileMenu 
						       details: (QActivityCapture fileDetails: fileToImport).
			f := FileDirectory default readOnlyFileNamed: fileToImport.
		] on: Error do: [ :ex |
			^ self inform: ('Cannot read file\  ', fileToImport) withCRs
		].
		f ifNotNil: [ session dropFile: f event: nil editBox: true]
	] ifNil: [
		QActivityCapture action: #ImportFileMenuAbandoned
	].! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:33'!
fileMenu
	| menu |
	menu := CMenu new.
	menu add: 'Exit' translateMe target: self action: #onExit.

	self runScript: #updateFileMenu when: {menu . #open}.
	^menu! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:32'!
helpMenu
	| menu |

	menu := CMenu new.
	menu add: 'User Guide...' translateMe target: self action: #openUserGuide.		"Stub"
	self runScript: #updateHelpMenu when: {menu . #open}.

	^menu! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:27'!
repopulateToolsMenu: menu
	| item |
	menu removeMenuItems.
	"--- Principal tools first ---"

	self hasExperimentalFeatures ifTrue: [
		item := menu add: 'Crowd...' translateMe target: crowdPane action: #toggle.
		self linkItem: item toTool: crowdPane
	].

	item := menu add: 'Documents...' translateMe target: documentsPane action: #toggle.
	self linkItem: item toTool: documentsPane.

	self hasPhoneSupport ifTrue: [
		item := menu add: 'Phone...' translateMe target: phonePane action: #toggle.
		self linkItem: item toTool: phonePane.
	].

	self hasSharePoint ifTrue:[
		item := menu add: 'SharePoint ...' translateMe target: repoBrowser action: #toggle.
		self linkItem: item toTool: repoBrowser.
	].

	self hasChat ifTrue:[
		item := menu add: 'Text Chat...' translateMe target: chatPane action: #toggle.
		self linkItem: item toTool: chatPane.
	].

	"Next group - construction-biased tools..."

	menu addSeparator.
	item := menu add: 'Object Catalog...' translateMe target: self action: #toggleCatalog.
	self linkItem: item toTool: catalogPane.

	item := menu add: 'Scene Inspector...' translateMe target: treeInspector action: #toggle.
	self linkItem: item toTool: treeInspector.
	item enabled: (self canModifyForum).

	item := menu add: 'Theme Materials...' translateMe target: materialCatalog action: #toggle.
	self linkItem: item toTool: materialCatalog.
	item enabled: (self canModifyForum).
	
	"-- Administration - user permissions ---"
	menu addSeparator.

	(menu add: 'Manage Users...' translateMe target: usersPane action: #editForumPermissions)
		tag: #addRemoveUsers;
		enabled: (self isAdministrator).

	"--- Tail group for personal settings ---"

	menu addSeparator.
	item := menu add: 'My Avatar...' translateMe target: avatarPane action: #toggle.
	self linkItem: item toTool: avatarPane.

	menu add: 'Preferences...' translateMe target: self action: #showPreferences.
	"Preferences is a dialog rather than a float, so it is not linked."

	menu add: 'Sound...' translateMe target: controlBar action: #adjustSound.

	QStyles installMenuFontInMenu: menu.
	
	self hasExperimentalFeatures ifTrue: [
		menu addSeparator.
		item := (
			menu
				add: 'Disable Video/PShare Decoding/Rendering' translateMe
				target: self
				action: #toggleReceiveButIgnoreVideo).
		item tag: #toggleReceiveButIgnoreVideo.
		item checked: (QJoshHacks receiveButIgnoreVideo).
	].

	^menu

! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:26'!
showAboutBox

	QActivityCapture countAction: #HelpMenuAbout.
	serviceMgr ifNotNil:[
		aboutBox serviceName value: ('Organization:' translateMe, ' ', (serviceMgr orgName)).
		aboutBox serviceHost value: ('Hosted At:' translateMe,' '), (login serviceHost).
		aboutBox tosLabel value: (self class tosLabelForOrg: (serviceMgr currentOrg)).

		self userLogin ifNotNilDo: [ : ln |
				aboutBox userLogin value: ('Logged In As:' translateMe,' ', ln)
			] ifNil:[
				aboutBox userLogin value:('Not Logged In' translateMe)
			]].

	aboutBox versionLabel label: (aboutBox infoString).
	aboutBox position: self dialogCenter;
			  layoutEverything.
	self add: aboutBox.
	aboutBox visible:true.! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:21'!
showFeedbackDialog
	QExitQuizDialog 
		runFor: self 
		quitLabel: 'Submit' translateMe
		questions: (QExitQuizDialog 
						surveyQuestions: self
						defaultStatement: 'My OpenQwaq experience is excellent.'
						verb: 'is'
						serviceManager: self serviceMgr)
		name: 'feedback'.! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:18'!
updateActionsMenu
	"Query the space for the currently available user Actions
	 and update the menu to present them."
	|  actions menu item |
	menu := self menu subMenuNamed: 'Actions' translateMe.
	menu ifNil: [ ^ self ].
	menu menuItems removeAll.

	self isReadonlyUser ifTrue: [
		"For readonly visitors, omit all the space-defined actions."
		self addFixedItemsToActionsMenu: menu.
		QStyles installMenuFontInMenu: menu.
		^ self.
	].
	(menu add: 'Add Landmark Here...' translateMe target: self action: #newPlaceMarker)
		enabled: (self canModifyForum);
		separator: true.

	self canModifyForum ifTrue: [
		actions := (activeSpace get:#actionVerbs) ifNil: [#()].
		actions do: [:a|
			(a first == #separator) ifTrue: [
			 	(menu menuItems size > 0) ifTrue: [
					menu menuItems last separator: true.
				]
			] ifFalse: [
				item :=menu add: (a second) 
						   target: self 
						   action: #performActionInSpace: 
						   argument: (a first).
				item enabled:(a first ~= #noSuchAction).
			]].
		self hasOfflineUploadSupport ifTrue: [
			menu add: 'Check for Offline Uploads' translateMe target: customsPane 
				action: #processOfflineUploadsWithNotice: arguments: {true}.
		].
	].

	"See up top also..."
	menu menuItems last separator: true.
	self addFixedItemsToActionsMenu: menu.

	QStyles installMenuFontInMenu: menu.
! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:14'!
updateEditMenu
	| menu hasSelection selSummary suffix hasPastes canModify |
	menu := self menu subMenuNamed: 'Edit' translateMe.
	menu ifNil: [ ^ self ].
	menu menuItems removeAll.

	selSummary := (avatar ifNotNil: [ avatar selectionSummary ]).
	hasSelection := (selSummary notNil).
	canModify := self canModifyForum.
	hasPastes := (avatar ifNotNil: [ avatar hasPastedFrames ] ifNil: [ false ]).
	suffix := selSummary ifNil: [''] ifNotNil:  [ ' ', selSummary ].

	(menu add: (undoRedoList undoLabel)  target: self action: #editUndo:)
		tag: #editUndo;
		enabled: (canModify and: [ undoRedoList canUndo ] ).

	(menu add:  (undoRedoList redoLabel) target: self action: #editRedo: )
		tag: #editRedo;
		enabled: (canModify and: [ undoRedoList canRedo ] ).

	menu addSeparator.

	(menu add: 'Cut' translateMe target: self action: #editCut:) 
		tag: #editCut;
		enabled: (hasSelection & canModify ) .

	(menu add: 'Copy' translateMe target: self action: #editCopy:) 
		tag: #editCopy;
		enabled: (hasSelection) .

	(menu add: 'Paste' translateMe target: self action: #editPaste:)
		tag: #editPaste;
		enabled: (canModify & hasPastes).

	menu addSeparator.

	(menu add: 'Delete' translateMe, suffix  target: self action: #editDelete:)
		tag: #editDelete;
		enabled: (canModify & hasSelection).

	hasSelection ifTrue: [
		menu addSeparator.
		(menu add: 'Locate' translateMe, suffix target: self action: #editLocate:)
			tag: #editLocate;
			enabled: (hasSelection).
		].! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:14'!
updateExtrasMenu
	"Preflight firing of the xtras menu."
	| menu deItem lmItem |
	menu := self menu subMenuNamed: 'Extras' translateMe.
	menu ifNil: [ ^ self ].
	
	"Put on-the-fly updates to the extras menu here:"
	(menu itemTagged: #extrasForumDetails) enabled: (self canModifyForum).
	(menu itemTagged: #extrasEntryPosition) 
		enabled: (self canModifyForum and: [ (self activeSpace get: #isPlacementLocked) == false ]).

	(menu itemTagged: #extrasChangePassword) enabled: (self isReusableGuestUser not).

	(menu itemTagged: #extrasTestMenu) 
		enabled: (meetingState isEditBlocked not or: [ self isMeetingLeader] ).
		"Not canmodifyforum above, so that visitors can test."

	"Miramar theme command thingy only shown to DE-enabled."
	deItem := menu itemTagged: #extrasWriteTheme.
	lmItem := menu itemTagged: #extrasEntryPosition.
	(deItem notNil and: [ self hasMiramarDesktopEdition not]) ifTrue: [
		menu menuItems remove: deItem.
		lmItem separator: true.
	] ifFalse: [
		(self hasMiramarDesktopEdition and: [ deItem isNil ]) ifTrue: [
			deItem := (menu add: 'Write Theme...' translateMe target: self action: #writeThemeFile).
			deItem tag: #extrasWriteTheme.
			menu menuItems remove: deItem.
			deItem := menu menuItems add: deItem after: lmItem.
			deItem separator: true.
			lmItem separator: false.
		]].
	
	menu signal: #menuItemsChanged.
! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 13:59'!
updateFileMenu
	| menu sub |
	menu := self menu subMenuNamed: 'File' translateMe.
	menu ifNil: [ ^ self ].
	menu menuItems removeAll.

	(menu add: 'Import...' translateMe target: self action: #fileImport) 
		tag: #fileImport;
		enabled: (self canModifyForum).
	(menu add: 'Web Link...' translateMe target: self action: #placeWebFileCard) 
		tag: #webCard;
		enabled: (self canModifyForum).
	menu addSeparator.

	"Personal Share. (Assumed not available unless the user gets permission in applyUserRole.)"
	sub := CMenu new.
	self runScript: #updateShareMenu when: {sub. #open}.
	(menu add: 'Share a Window' translateMe subMenu: sub) tag: #shareMenu.

	self hasPersonalShareVNC ifTrue: [
		(menu add: 'Connect to VNC' translateMe target: self action: #personalShareVNC) 
			tag: #vncShare;
			enabled: self canModifyForum.
	].
	menu addSeparator.
	(menu add: 'Save Forum' translateMe target: self action: #saveForum) 
		tag: #fileSave;
		enabled: (self canModifyForum).

	(menu add: 'Save Copy As...' translateMe target: self action: #saveForumAs) 
		tag: #fileSaveAs;
		enabled: (self isAdministrator).

	(menu add: 'Save As Template...' translateMe target: self action: #saveForumAsTemplate) 
		tag: #fileSaveAsTemplate;
		enabled: (self isAdministrator).

	menu addSeparator.
	(menu add: 'Save All Forums' translateMe target: self action: #saveAllForums) 
		tag: #fileSaveAll;
		enabled: (self canModifyForum).

	menu addSeparator.
	menu add: 'Go to Lobby' translateMe target: self action: #logoff.
	menu add: 'Exit' translateMe target: self action: #onExit.
	^menu! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:09'!
updateHelpMenu
	| menu |

	menu := self menu subMenuNamed: 'Help' translateMe.
	menu ifNil: [ ^ self ].
	menu menuItems removeAll.

	menu add: 'User Guide...' translateMe target: self action: #openUserGuide.
	menu addSeparator.
	(menu add: 'Forum Welcome...' translateMe target: self action: #showForumWelcome) 
		enabled: (activeSpace isValidFarRef and: [ (activeSpace get: #welcomeDocument) notNil ]).

	menu addSeparator.
	menu add: 'Moving With the Keyboard...' translateMe target: self action: #showQuickReference:url:
		 	arguments: #('qhelp_navkeys.jpg' 'navigation.html').
	menu add: 'Moving With the Mouse...' translateMe target: self action: #showQuickReference:url:
			arguments: #('qhelp_navmouse.jpg' 'navigation.html').
	menu add: 'Importing Content...' translateMe target: self action: #showQuickReference:url:
			arguments: #('qhelp_import_content.jpg' 'importing_content.html').
	menu add: 'Traveling By Portal...' translateMe target: self action: #showQuickReference:url: 
			arguments: #('qhelp_portals.jpg' 'portals_and_spaces.html').
	menu add: 'Using Sound...' translateMe target: self action: #showQuickReference:url:
			arguments: #('qhelp_sound.jpg' 'communication.html').

	"no valid content any more
	menu addSeparator.
	menu add: 'Introductory Movies...' target: self action: #gotoHelpMovieIndexPage.
	menu add: 'Getting Started With Voice...' target: self action: #gotoSoundHelpMoofie.
	"

	(serviceMgr notNil 
		and: [ serviceMgr currentOrg notNil] 
		and: [ serviceMgr currentOrg isFreeTrial]
		and: [ serviceMgr currentOrg contact = self userLogin]
	) ifTrue: [
		menu addSeparator.
		menu add: 'Buy Now...' translateMe target: login action: #goToBuyNow: argument: serviceMgr currentOrg.
	].
	menu addSeparator.
	menu add: 'Feedback...' translateMe target: self action: #showFeedbackDialog.
	menu add: 'About...' translateMe target: self action: #showAboutBox.
	^menu! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:06'!
updateShareMenu
	"Query the space for the currently available user actions
	 and update the menu to present them."
	|  menu enabled list |
	menu := (self menu itemTagged: #shareMenu) subMenu.
	menu ifNil: [ ^ self ].
	menu menuItems removeAll.
	enabled := self canModifyForum and:[self hasMiramarPersonalShare].
	(menu add: 'Open a File...' translateMe target: self action: #shareFile)
		tag: #shareFile;
		enabled: enabled.
	menu addSeparator.
	"Sort list alphabetically"
	list := (QPersonalShare sharableWindows collect:[:wid|
		(QPersonalShare windowLabelFor: wid) -> wid.
	]) sort.
	list size > 20 ifTrue:[list := list copyFrom: 1 to: 20].
	list do:[:assoc| | lbl |
		lbl := assoc key.
		(menu add: (lbl truncateWithElipsisTo: 50)
			target: self 
			action: #shareWindow:
			argument: assoc value)
				icon: (QPersonalShare windowIconFor: assoc value);
				tag: #shareWindow;
				enabled: enabled].
	menu addSeparator.
	(menu add: 'All Sharable Windows...' translateMe target: self action: #showWindowSharePane) enabled: enabled.! !

!QwaqParticipantUI methodsFor: 'menu' stamp: 'sn 5/13/2011 14:48'!
viewMenu
	| menu vps item subMenu |
	menu := CMenu new.

	"Have to get the order right.
	 Note that several update routines assume that the first n elements
	 of this menu are the viewpoint positions from the viewpoint table."
	vps := {'First Person'. 'Near'. 'Normal'. 'Far'}.
	(QUserPreferences viewpointTable keys includesAllOf: vps) ifFalse: [
		self error: 'Viewpoint menu doesn''t match preference options.'.
	].
	vps do:[:lbl |
		menu add: lbl translateMe target: self action: #changeViewpoint: argument: lbl.
	].

	menu addSeparator.
	menu add: 'Name Tags' translateMe subMenu: (CMenu new).	 "See updateNametagMenu:"

	"--- Middle-group for some readouts (i.e. view this information...)  ---"
	menu addSeparator.
	item := menu add: 'Network Activity...' translateMe target: trafficPane action: #toggle.
	self linkItem: item toTool: trafficPane.
	item := menu add: 'Performance...' translateMe target: statisticsPane action: #toggle.
	self linkItem: item toTool: statisticsPane.
	item := menu add: 'Transcript...' translateMe target: logView action: #toggle.
	self linkItem: item toTool: logView.

	"Useless stereo-rendering toy."
	menu addSeparator.
	subMenu := CMenu new.
	item := subMenu add: 'Off' translateMe target: self action: #stereoOff.
	item checked:true.
	item := subMenu add: 'Hardware' translateMe target: self action: #stereoHardware.
	item := subMenu add: 'Anaglyph' translateMe target: self action: #stereoAnaglyph.
	menu add: 'Stereoscopic' translateMe subMenu: subMenu.

	menu addSeparator.
	(menu add: 'Full Screen' translateMe target: self action: #toggleFullScreen)
		checked: (Tweak fullScreenMode);
		"Full Screen does not work if we are running in a browser 
		 as an ActiveX Control, so ensure that the menu pick is disabled."
		disabled: (QActiveXControl current isActive);
		tag: #fullscreen.

	self startScript: #updateViewMenu when: {menu . #open }.
	^menu! !

!QwaqParticipantUI methodsFor: 'objects' stamp: 'sn 5/13/2011 15:26'!
forumsMenu

	"To seed the menu; just has a default command."
	| menu |
	menu := CMenu new.
	menu add: 'All Forums...' translateMe target:  self action: #showServicesPane.
	self runScript: #updateForumsMenu when: {menu . #open}.
	^menu

! !

!QwaqParticipantUI methodsFor: 'status' stamp: 'sn 5/13/2011 22:55'!
defaultStatusMessage
	| nPeople |

	self readyForEvents ifFalse: [ ^ nil ].
	nPeople := usersPane nPeopleHere.
	nPeople = 0 ifTrue: [  ^ 'There may be a connection problem.' ].
	
	self isMeetingInProgress ifFalse: [ ^ self idlingMessage ].

	(self isMeetingLeader not 
	 and: [meetingState audienceIsMuted ]
	 and: [ meetingState isLoginAllowedToSpeak: self userLogin ]) ifTrue: [
		^ 'You may speak' translateMe, 
		    (controlBar microphone selected
			ifFalse: [' - but your microphone is off. ']
		 	ifTrue: [ ' now. ']).
	].

	^ controlBar meetingStatusString, ' ', (self idlingMessage)! !

!QwaqParticipantUI methodsFor: 'meetings' stamp: 'sn 5/13/2011 17:07'!
meetingMenu
	"Seed the 'Meeting' main menu.  See updateMeetingMenu, which rebuilds on the fly."
	| menu |
	menu := CMenu new.
	(menu add: 'Lead Meeting' translateMe target: self action: #toggleMeetingLeadership: arguments: { true })
		checked: false;	
		tag: #leadTheMeeting;
		separator: true.

	self runScript: #updateMeetingMenu when: {menu . #open}.
	^menu! !

!QwaqParticipantUI methodsFor: 'meetings' stamp: 'sn 5/13/2011 17:07'!
updateMeetingMenu
	| menu bringing topLabel canChangeLeader leader here |
	menu := self menu subMenuNamed: 'Meeting' translateMe.
	menu ifNil: [ ^ self ].
	menu menuItems removeAll.
	self readyForEvents ifFalse: [
		menu add: 'System Not Ready' target: self action: #noSuchThing.
		^ menu
	].

	here := (avatar replica get: #nominalPlace).	
	bringing := (meetingState meetingPlace ifNotNilDo: [ : place | place isFollowMePlace ] ifNil:[false]).
	leader := self meetingLeader.

	"Leader is changeable by any normal member unless 'Permit Changes' is off.
	 Also changeable if the leader is away, or idle (no action or sound for > 1 minute)"
	canChangeLeader := 
		leader ifNil: [ self isReadonlyUser not ]
			    ifNotNil: [ 
		      		isMeetingLeader
					or: [ self isReadonlyUser not and: [ leader isAway or: [ leader isIdle ] ] ]
					or: [ self canModifyForum ]].
	topLabel := canChangeLeader
					ifTrue: [ (leader isNil or: [ leader isMe ])
								ifTrue: [ 'Lead Meeting' ] 
								ifFalse: [ 'Take Over From ', (leader publicName)] ]
					ifFalse: [ leader 
								ifNil: [ 'Lead Meeting' ]
								ifNotNil: [ 'Led by ', (leader publicName) ] ].
	(menu add: topLabel target: self action: #toggleMeetingLeadership: arguments: {isMeetingLeader} )
			checked: isMeetingLeader;	
			tag: #leadTheMeeting;
			separator: true;
			enabled: canChangeLeader.

	(menu add: 'All Follow Me' 
			target: self
			action: #bringEveryoneWithMe:
			argument: (bringing not))
			enabled: isMeetingLeader;
			checked: bringing.

	(menu add: 'Meet Here' 
			target: self 
			action: #toggleMeetingWhereIAm)
			enabled: (here notNil 
						and: [ here isStatic not ] and: [ here posture ~= #Sitting ] 
						and: [ here isFollowMePlace not or: [ isMeetingLeader ] ]
						and: [ canChangeLeader ]);
			checked: (here notNil and:[here = (meetingState meetingPlace)]);
			separator: true.

	(menu add: 'Tally a Question...' 
			target: self
			action: #askEveryoneAQuestion:)
			enabled: (isMeetingLeader or: [ leader isNil and: [ self canModifyForum ] ]);
			separator: true.

	(menu add: 'Restrict Changes'
			target: self
			action: #toggleEditBlocked)
			enabled: isMeetingLeader;
			checked: (meetingState isEditBlocked) .

	(menu add: 'Restrict Movement'
			target: self
			action: #toggleStayPut)
			enabled: (isMeetingLeader and: [ bringing not ]);
			checked: (meetingState audienceStayPut) | bringing.

	(menu add: 'Restrict Private Text'
		target: self
		action: #toggleRestrictPrivateText)
		enabled: isMeetingLeader;
		checked: (meetingState isPrivateTextBlocked).
	(menu add: 'Restrict Voice Chat'
			target: self 
			action: #toggleMuteAudience)
			enabled: isMeetingLeader;
			checked: (meetingState audienceIsMuted).
	menu menuItems last separator: true.
	(menu add: 'All Reset Sound' 
		    target: self
		    action: #broadcastResetSound)
		    enabled: (isMeetingLeader or: [ leader isNil and: [self canModifyForum]]).
	(menu add: 'All Test Experience' 
		    target: self
		    action: #broadcastTestClientExperience)
		    enabled: (isMeetingLeader or: [ leader isNil and: [self canModifyForum]])		! !

!QwaqParticipantUI methodsFor: 'roles&capabilities' stamp: 'sn 5/13/2011 14:48'!
applyUserRole
	"A new user role has been put into play for this user...
	 update all the non-self-regulating menu items, etc, in the UI "

	self repopulateToolsMenu: (self menu itemNamed: 'Tools' translateMe) subMenu.

	controlBar applyUserRole.
	usersPane applyUserRole.
	servicesPane applyUserRole.

	self updateTitle.

	"Pass along into the avatar..."
	self readyForEvents ifTrue: [
		avatar replica
			future capabilities: (self capabilities asArray)
			features: (self currentFeatures asArray).	
	].

	self updateMobility.! !

!QwaqParticipantUI methodsFor: 'logon-off' stamp: 'sn 5/13/2011 22:21'!
confirmQuit: logout
	"Handle normal logout and exit requests...
	 check unsaved states and warn if we're past due,
	 offering to save-all in that case.
	 The logout arg is just to have the labeling suit the action."
	| msg time unsaved mins needSave dlog result shortLabel stayingOpen |

	needSave := false.
	stayingOpen := (logout ~= false).

	"If autosave is enabled, then there's already a save underway since we're quitting.
	 If we're errored-out or otherwise disconnected, don't offer the option of saving."
	(preferences doAutoSave not 
	    and: [self readyForEvents]
	    and: [self canModifyForum]) 
	 ifTrue: [
		time := Time utcSeconds.
		unsaved := servicesPane entriesUnsaved.
		unsaved size > 0 ifTrue: [
			needSave := true.
			msg := (self longQuitDescription: logout),  '? '.
			msg := msg, String cr, String cr, 'There may be unsaved changes:', String cr, String cr.
			unsaved do: [ :e|
				mins := ((time - e lastSaveTime) // 60) max: 1.
				mins < 60 ifTrue: [
					msg := msg, 
						String tab, e name, ' (last saved ', mins, ' minute', 
									((mins == 1) ifTrue: [' ago)'] ifFalse: ['s ago)']),
						String cr.
				] ifFalse: [
					msg := msg, String tab, e name, ' (not saved for over an hour)', String cr.
				].
			].
			msg := msg, String cr,
					'Auto-save is disabled in your preferences.', String cr.
		].
	].

	msg ifNil: [
		"Nothing needs saving"
		self useQuickTimeouts.
		^ self finalQuitConfirm: logout afterSaveWasChecked: false.
	].

	dlog := CUserDialog new.
	dlog label: 'Confirm' translateMe.
	dlog message: msg.
	dlog messageText allowEditing: false.
	dlog messageText hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	shortLabel :=  (self shortQuitLabel: logout).
	needSave ifTrue: [
		(dlog addButton: 'Save and' translateMe,' ', shortLabel value: #save)
			width: (stayingOpen ifTrue: [130] ifFalse: [112]).
		(dlog addButton:  shortLabel, ', Don''t Save' translateMe value: #exit)
			width: (stayingOpen ifTrue: [142] ifFalse: [122]).
	] ifFalse: [
		(dlog addButton: shortLabel value: #exit)
	].
	dlog addButton: 'Cancel' translateMe value: #cancel.

	okToQuit := true.	"Set to false if an error occurs in save."

	result := (dlog run: #save centerAt: (self dialogCenter)) 
		caseOf: {
			[#save] -> [ self saveAllForums.  okToQuit ].
			[#exit ] -> [ true ]
		} otherwise: [ false ].

	^ result ifTrue: [ 
				self useQuickTimeouts.
				self finalQuitConfirm: logout afterSaveWasChecked: true ] 
			 ifFalse: [ 
				self useNormalTimeouts.
				false ].! !

!QwaqParticipantUI methodsFor: 'logon-off' stamp: 'sn 5/13/2011 13:56'!
shortQuitLabel: logout
	"A short label suitable for a button, indicating the action that will be taken on quitting this forum."
	^logout caseOf: {
		[true] -> ['Go to Lobby' translateMe].
		[false] -> ['Quit' translateMe]
	} otherwise: ['Go' translateMe]. "going to another service"
	! !

!QwaqParticipantUI methodsFor: 'preferences' stamp: 'sn 5/13/2011 14:55'!
changeViewpoint: aViewpointOption

	|aScalar|
	aScalar := QUserPreferences viewpointTable at: aViewpointOption ifAbsent: [1.5].

	self changeViewpointValue: aScalar.

	"Make the on-the-fly PoV menu show the right checkmark."
	(self menu itemNamed: 'View' translateMe) subMenu menuItems asArray
		from: 1 to: (QUserPreferences viewpointTable size)
		do: [ :item|
			item checked: (item label = aViewpointOption).
		].
! !

!QwaqParticipantUI methodsFor: 'preferences' stamp: 'sn 5/13/2011 14:49'!
onPointOfViewPrefChanged
	<on: pointOfViewChanged in: preferences>

	"The avatar could do this, since it has a handle on the preferences,
	  but doing it here keeps the prefs handlers together."

	self changeViewpointValue: (preferences povValue).

	"Make the dynamic menu match."
	(self menu itemNamed: 'View' translateMe) subMenu menuItems asArray
		from: 1 to: (QUserPreferences viewpointTable size) do: [ :item|
		item checked: (item label = preferences pointOfView).
	].
! !

!QwaqParticipantUI methodsFor: 'preferences' stamp: 'sn 5/13/2011 14:55'!
updateViewMenu
	"Match the checkmark in the viewpoint menu to the current state of the avatar camera."
	| menu minDelta minItem |

	(mainView notNil and: [avatar notNil]) ifFalse: [ ^ self ].

	menu := (self menu itemNamed: 'View' translateMe) subMenu.

	"These choices are the first n entries in the menu."
	minDelta := Float infinity.
	minItem := nil.
	menu menuItems asArray
	from: 1 to: (QUserPreferences viewpointTable size) do: [ :item|
		| di |
		item checked: false.
		di := (avatar currentThirdPerson - 
				(QUserPreferences viewpointTable at: (item label) ifAbsent:[0])) abs.
		di < minDelta ifTrue: [
			minDelta := di.
			minItem := item.
		].
	].
	minDelta < 0.5 ifTrue: [
		minItem ifNotNil: [ minItem checked: true ].
	].

	self updateNametagMenu: (menu itemNamed: 'Name Tags' translateMe) subMenu.
	(self menu itemTagged: #fullscreen) 
		checked: (Tweak fullScreenMode).
! !


!QwaqParticipantUI class methodsFor: 'deployment' stamp: 'sn 5/13/2011 23:12'!
cleanup
	"Do various bits of cleanup to ensure a safe restart"
	ScriptProcess allInstancesDo:[:sc| sc terminate].
	QStyles clear.
	QForms clear.
	QServiceProvider reset.
	TConnectionDispatcher reset.
	TContentManager default:nil.
	TIslandController initialize.
	TFarRef initialize.
	QClientSpeakerOutput allSubInstancesDo: [:v|v stop].
	QwaqSanityChecker allInstancesDo: [:i| i destroy ].
	TSpace allSubInstancesDo: [:tf | tf obliterate].
	QServiceDescription initialize.
	TObjectID resetLogs.
	Island classPool at:#Default put: nil.
	Smalltalk garbageCollect.
	TIslandController allSubInstancesDo: [:t|t destroy].
	TContactPoint allInstancesDo: [:tp | tp destroy].
	MCMethodDefinition shutDown.
	MCFileBasedRepository flushAllCaches.
	MCDefinition clearInstances.
	Smalltalk garbageCollect.
	ChangeSet allInstances do:[:cs|
		cs == ChangeSet current
			ifFalse:[ChangeSet removeChangeSet: cs]].
! !


!QwaqPrefsPane methodsFor: 'initialize' stamp: 'sn 5/8/2011 20:20'!
setupCostume

	super setupCostume.
	QFloatingPane setupDialog: self.
	self extent: (self class fixedExtent).
	self graphicForm: (QForms find: 'PaneFill.gif'); graphicFit: #tile.

	title := CLabel on: 'Your Preferences' translateMe.
	title font: QToolPane titleFont;
		textEmphasis:1;
		textColor: (QToolPane titleColor);
		hResizing: #shrinkWrap;
		fullBounds.
	title topLeft: 12@11.
	self add:title.

	infoTabButton label: 'Public Profile' translateMe;
		font: QStyles controlFont;
	 	extent: 90@25;
		roundCornerSpec: #(1 4);
		borderColor: Color veryLightGray;
	 	fullBounds;
 		topLeft: title bottomLeft + (0@12).
	self add: infoTabButton.

	prefsTabButton label: 'Preferences' translateMe;
		font: QStyles controlFont;
		extent: 90@25;
		roundCornerSpec: #(1 4);
		borderColor: Color veryLightGray;
		fullBounds;
		topLeft: (infoTabButton topRight) + (8@0).
	self add: prefsTabButton.

	{prefsPage . infoPage} do: [ :page |
		page
			fillColor: (QColors innerPaneColor);
			fillAlpha: (0.6);
			topLeft: infoTabButton bottomLeft - (0@1);
			roundCornerSpec: #(2 3 4);
			extent: (width - 22)@(height  - (page top + 50));
			borderStyle: #simple; 
			borderColor: Color veryLightGray; 
			borderWidth: 1.
		].
	self setupInfoPage.
	self setupPrefsPage.

	"DIALOG BUTTONS" 

	okButton label: 'OK' translateMe;
		 font: QStyles controlFont;
	 	 extent: 70@25;
		 fullBounds;
		 topRight: 200@(self height-39);
		 roundCorners: true.
	self add: okButton.

	applyButton label: 'Apply' translateMe;
		 font: QStyles controlFont;
	 	 extent: 70@25;
		 fullBounds;
		 center: 278@(self height -27);
		 roundCorners: true.
	self add: applyButton.

	cancelButton label: 'Cancel' translateMe;
		 font: QStyles controlFont;
	 	 extent: 70@25;
		 fullBounds;
		 topLeft: 356@(self height - 39);
		 roundCorners: true.
	self add: cancelButton.

	fakeTabDoober borderWidth: 1; 
				    borderStyle: #simple; 
				    borderColor: (Color gray:0.9).
	self add: fakeTabDoober.
	curPage := infoPage.! !

!QwaqPrefsPane methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:12'!
setupInfoPage

	| label midLeft midRight farRight personalY |
	"PERSONAL INFO - NAME, COLOR, PICTURE, EMAIL, TEXT"
	"The gutter between labels and fields"
	midLeft := 120.
	midRight := 125.
	farRight := 315.
	personalY := 20.

	label := CLabel on: 'Screen Name:' translateMe.
	label font: QStyles controlFont;
		  hResizing: #shrinkWrap;
		  balloonHelp: (self screenNameHelp);
		  fullBounds;
		  topRight: midLeft@personalY.
	infoPage add: label.
	screenName topLeft: midRight@personalY;	
		hResizing: #spaceFill;
		width: (160);
		balloonHelp: (self screenNameHelp).
	infoPage add: screenName.

	label := CLabel on: 'My Color:' translateMe.
	label font: QStyles controlFont;
		 hResizing: #shrinkWrap;
		 fullBounds;
		 topLeft: (farRight)@personalY;
		balloonHelp: (self avatarColorHelp).
	infoPage add: label.
	label fullBounds.
	avatarColor topLeft: (label topRight x + 3)@personalY;	
		hResizing: #shrinkWrap;
		balloonHelp: (self avatarColorHelp).
	infoPage add: avatarColor.

	label := CLabel on: 'My Picture:' translateMe.
	label font: QStyles controlFont;
		  hResizing: #shrinkWrap;
		  fullBounds;
		  topRight: midLeft@(personalY+28);
		  balloonHelp: (self pictureHelp).
	infoPage add: label.
	photo topLeft: midRight+1@(personalY+29);	
		borderStyle: #simple;
		borderColor: (Color black);
		borderWidth: 1;
		height: 64;
		width: 64;
		balloonHelp: (self pictureHelp).
	infoPage add: photo.
	getPicture font: QStyles controlFont;
		label: 'Browse...' translateMe;
		topLeft: (midRight + photo width + 12)@(personalY+29);
		roundCorners:true;
		extent: 80@24;
		balloonHelp: (self pictureHelp).
	infoPage add: getPicture.

	label := CLabel on: 'Public E-Mail:' translateMe.
	label font: QStyles controlFont;
			hResizing:#shrinkWrap;
			fullBounds;
			topRight: midLeft@(personalY+103);
		balloonHelp: (self emailHelp).
	infoPage add: label.
	email
		topLeft: midRight@(personalY+103);
		hResizing: #spaceFill;
		width: (self width-182); height:19;
		balloonHelp: (self emailHelp).
	infoPage add: email.

	label := CLabel on: 'About Me:' translateMe.
	label font: QStyles controlFont;
		  hResizing: #shrinkWrap;
		 fullBounds;
		  topRight: midLeft@(personalY+133);
		balloonHelp: (self descriptionHelp).
	infoPage add: label.
	description
		topLeft: midRight@(personalY+132);
		color: (Color white);
		hResizing: #spaceFill;
		width: (self width - 182);
		height: (100);
		balloonHelp: (self descriptionHelp).
	infoPage add: description.
! !

!QwaqPrefsPane methodsFor: 'initialize' stamp: 'sn 5/13/2011 13:52'!
use: aQPrefs

	| sn |
	prefs := aQPrefs.

	title label: 'Your Preferences' translateMe, '(','Account' translateMe, ' ''', prefs userLogin, ''')'.

	photo graphicForm: (prefs smallPicture).
	photo graphicFit: #scale.

	sn := prefs screenName.
	screenName value: (sn isEmptyOrNil ifTrue: [ '' ] ifFalse: [sn]).
	email value: (prefs publicEmail ifNil: ['']).
	description value: (prefs personalSummary ifNil: ['']).
	avatarColor value: (prefs avatarColor ifNil: ['(Random)']).

	doAutoSave value: prefs doAutoSave.
	doAA value: prefs doAntialiasing.
	doActivityReports value: prefs doActivityReports.
	doEnableVideo value: prefs videoDisabled not.
	useAcceleratedAnimation value: prefs acceleratedAnimation ~= #none.
	doSound value: prefs doSoundEffects.
	useOpenAL value: prefs useOpenAL.
	doNavPanel value: prefs doNavPanel.

	(homeOrgChoice contents includes: (prefs homeOrganization))
	 ifTrue: [
		homeOrgChoice value: (prefs homeOrganization).
	] ifFalse: [
		prefs homeOrganization isEmptyOrNil ifFalse: [
			QLogger logWarning: 'Unknown home-org: ' , (prefs homeOrganization).
		].
		homeOrgChoice value: (self class noHomeOrgChoice).
	].

	showNamesMenu value: (self showNamesChoiceFrom: prefs).
	idleFrameRateMenu value: (self idleFrameRateChoiceFrom: prefs).
	showMy3DPointer value: prefs showMy3DPointer.
	viewpointMenu value: prefs pointOfView.
	viewAngleMenu value: prefs viewAngle.
	
	forumCacheSize value: (prefs forumCacheSize).
	forumCacheAge value: (prefs forumCacheAge).! !


!TranscriptStream class methodsFor: 'class initialization' stamp: 'sn 5/13/2011 23:51'!
initialize
	"The transcript slows down if using antialiased TT fonts,
       so we don't use 'default text font' for the Transcript;
	 instead we bind the transcript to a bitmap strike font."
	AccessMutex := Mutex new.
	self useStyle: #LiberationMono size: 12.	"Big and ugly, but some folks like that."
	self registerInFlapsRegistry.	

	"TranscriptStream initialize."
! !

TranscriptStream initialize!
