'From Squeak4.1 of 17 April 2010 [latest update: #9957] on 5 May 2011 at 7:22:46 pm'!
LanguageEnvironment subclass: #RussianEnvironment
	instanceVariableNames: ''
	classVariableNames: 'RussianToLatinKeyboardMap'
	poolDictionaries: ''
	category: 'Multilingual-Languages'!

!RussianEnvironment commentStamp: 'sn 7/31/2009 15:23' prior: 0!
EncodedCharSet initialize.
LanguageEnvironment resetKnownEnvironments.
Locale switchToID: (LocaleID isoLanguage: 'ru').
!


!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 16:05'!
defaultEncodingName

	^'utf-8' copy! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:15'!
flapTabTextFor: aString

	^ aString.
! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:15'!
flapTabTextFor: aString in: aFlapTab

	^ aString.
! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 4/1/2011 18:49'!
initializeRussianToLatinKeyboardMap

	"self initializeRussianToLatinKeyboardMap"
	| mapPairs |
	RussianToLatinKeyboardMap := Dictionary new.
	mapPairs :=  #( #(1081 113) #(1094 119) #(1091 101) #(1082 114) #(1077 116) #(1085 121) #(1075 117) #(1096 105) #(1097 111) #(1079 112) #(1093 91) #(1098 93) #(1092 97) #(1099 115) #(1074 100) #(1072 102) #(1087 103) #(1088 104) #(1086 106) #(1083 107) #(1076 108) #(1078 59) #(1101 39) #(1103 122) #(1095 120) #(1089 99) #(1084 118) #(1080 98) #(1090 110) #(1100 109) #(1073 44) #(1102 46) #(1049 81) #(1062 87) #(1059 69) #(1050 82) #(1045 84) #(1053 89) #(1043 85) #(1064 73) #(1065 79) #(1047 80) #(1061 123) #(1066 125) #(1060 65) #(1067 83) #(1042 68) #(1040 70) #(1055 71) #(1056 72) #(1054 74) #(1051 75) #(1044 76) #(1046 58) #(1069 34) #(1071 90) #(1063 88) #(1057 67) #(1052 86) #(1048 66) #(1058 78) #(1068 77) #(1041 60) #(1070 62) ) .
	mapPairs do: [:p | 
		RussianToLatinKeyboardMap
			at: (p first asCharacter)
			put: p second asCharacter]! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:16'!
isBreakableAt: index in: text

	| char |
	char := text at: index.
	char = Character space ifTrue: [^ true].
	char = Character cr ifTrue: [^ true].
	char = Character lf ifTrue: [^ true].
	^ false.
! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:16'!
nextPutRightHalfValue: ascii toStream: aStream withShiftSequenceIfNeededForTextConverterState: state

	^ self traditionalCharsetClass nextPutRightHalfValue: ascii toStream: aStream withShiftSequenceIfNeededForTextConverterState: state.
! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:16'!
nextPutValue: ascii toStream: aStream withShiftSequenceIfNeededForTextConverterState: state

	^ self traditionalCharsetClass nextPutValue: ascii toStream: aStream withShiftSequenceIfNeededForTextConverterState: state.! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 4/1/2011 18:48'!
originalKeyShortcutFromRussian: char
	
	^RussianToLatinKeyboardMap at: char ifAbsent: [char]! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:17'!
traditionalCharsetClass

	^ Unicode.
! !


!TTFileDescription class methodsFor: 'font paths' stamp: 'sn 5/5/2011 19:08'!
fontPathsDoOld: aBlock
	"Evaluate aBlock with all of the font paths that should be searched on the current platform"

	"Start with the current directory"
	aBlock value: FileDirectory default pathName.

	"Then subdirectory 'fonts'"
	aBlock value: (FileDirectory default directoryNamed: 'fonts') pathName.

	"Platform specific directories"
	SmalltalkImage current platformName caseOf:{
		['Win32']	->	[
			"Standard Windows fonts directory"
			aBlock value: 'C:\Windows\Fonts'.
		].
		['Mac OS']	->	[
			"Standard system fonts directory"
			aBlock value: '/Library/Fonts'.
		].
		['unix']		->	[ | base |
			"Standard fonts are in /usr/share/fonts/*"
			base := '/usr/share/fonts'.
			(FileDirectory on: base) directoryNames 
				do:[:dn| aBlock value: base, '/', dn].
		].
	} otherwise:[].
	! !


!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:15'!
clipboardInterpreterClass

	^ UTF8ClipboardInterpreter! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:15'!
fileNameConverterClass

	^ self systemConverterClass
! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 4/2/2011 19:11'!
inputInterpreterClass
	
	^ UTF32RussianInputInterpreter! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 14:16'!
leadingChar

	^ 15.
! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'yo 12/11/2007 11:22'!
supportedLanguages
	"Return the languages that this class supports. 
	Any translations for those languages will use this class as their environment."
	
	^#('ru' )! !

!RussianEnvironment class methodsFor: 'as yet unclassified' stamp: 'sn 2/12/2011 16:06'!
systemConverterClass

	^ UTF8TextConverter! !


!TTFileDescription class methodsFor: 'font paths' stamp: 'sn 5/5/2011 19:08'!
fontPathsDo: aBlock
	"Evaluate aBlock with all of the font paths that should be searched on the current platform"

	aBlock value: (FileDirectory default directoryNamed: 'fonts') pathName.! !


!UTF32RussianInputInterpreter methodsFor: 'keyboard' stamp: 'sn 5/5/2011 17:55'!
nextCharFrom: sensor firstEvt: evtBuf 
	"Fall back on MacRoman if char is 0"
	|keyValue char|
	
	keyValue := evtBuf at: 6.
	keyValue > 0
		ifTrue: [char := (evtBuf at: 6) asCharacter]
		ifFalse: [char := (evtBuf at: 3) asCharacter macToSqueak].

	^(evtBuf at: 5) > 2 "Alt or Ctrl pressed?"
		ifTrue: [ RussianEnvironment  originalKeyShortcutFromRussian: char ]
		ifFalse: [ char ] .! !


!UTF8TextConverter class methodsFor: 'conversion' stamp: 'sn 5/5/2011 17:56'!
decodeByteString: aByteString
	"Convert the given string from UTF-8 using the fast path if converting to Latin-1"

	| outStream lastIndex nextIndex byte1 byte2 byte3 byte4 unicode |
	lastIndex := 1.
	(nextIndex := ByteString findFirstInString: aByteString inSet: latin1Map startingAt: lastIndex) = 0
		ifTrue: [ ^aByteString ].
	outStream := (String new: aByteString size) writeStream.
	[
		outStream next: nextIndex - lastIndex putAll: aByteString startingAt: lastIndex.
		byte1 := aByteString byteAt: nextIndex.
		(byte1 bitAnd: 16rE0) = 192 ifTrue: [ "two bytes"
			byte2 := aByteString byteAt: (nextIndex := nextIndex + 1).
			(byte2 bitAnd: 16rC0) = 16r80 ifFalse:[	^self errorMalformedInput: aByteString ].
			unicode := ((byte1 bitAnd: 31) bitShift: 6) + (byte2 bitAnd: 63)].
		(byte1 bitAnd: 16rF0) = 224 ifTrue: [ "three bytes"
			byte2 := aByteString byteAt: (nextIndex := nextIndex + 1).
			(byte2 bitAnd: 16rC0) = 16r80 ifFalse:[ ^self errorMalformedInput: aByteString ].
			byte3 := aByteString byteAt: (nextIndex := nextIndex + 1).
			(byte3 bitAnd: 16rC0) = 16r80 ifFalse:[ ^self errorMalformedInput: aByteString ].
			unicode := ((byte1 bitAnd: 15) bitShift: 12) + ((byte2 bitAnd: 63) bitShift: 6)
				+ (byte3 bitAnd: 63)].
		(byte1 bitAnd: 16rF8) = 240 ifTrue: [ "four bytes"
			byte2 := aByteString byteAt: (nextIndex := nextIndex + 1).
			(byte2 bitAnd: 16rC0) = 16r80 ifFalse:[ ^self errorMalformedInput: aByteString ].
			byte3 := aByteString byteAt: (nextIndex := nextIndex + 1).
			(byte3 bitAnd: 16rC0) = 16r80 ifFalse:[ ^self errorMalformedInput: aByteString ].
			byte4 := aByteString byteAt: (nextIndex := nextIndex + 1).
			(byte4 bitAnd: 16rC0) = 16r80 ifFalse:[ ^self errorMalformedInput: aByteString ].
			unicode := ((byte1 bitAnd: 16r7) bitShift: 18) +
							((byte2 bitAnd: 63) bitShift: 12) + 
							((byte3 bitAnd: 63) bitShift: 6) +
							(byte4 bitAnd: 63)].
		unicode ifNil: [ ^self errorMalformedInput: aByteString ].
		unicode = 16rFEFF ifFalse: [ "Skip byte order mark"
			outStream nextPut: ("Unicode value: "unicode asCharacter) ].
		lastIndex := nextIndex + 1.
		(nextIndex := ByteString findFirstInString: aByteString inSet: latin1Map startingAt: lastIndex) = 0 ] whileFalse.
	^outStream 
		next: aByteString size - lastIndex + 1 putAll: aByteString startingAt: lastIndex;
		contents
! !

"Postscript:
."

RussianEnvironment initializeRussianToLatinKeyboardMap!

